/*
 Illinois Open Source License

 University of Illinois/NCSA
 Open Source License

 Copyright © 2009,    University of Illinois.  All rights reserved.

 Developed by:
 Innovative Systems Lab
 National Center for Supercomputing Applications
 http://www.ncsa.uiuc.edu/AboutUs/Directorates/ISL.html

 Permission is hereby granted, free of charge, to any person obtaining a copy of this 
 software and associated documentation files (the "Software"), to deal with the Software 
 without restriction, including without limitation the rights to use, copy, modify, merge, 
 publish, distribute, sublicense, and/or sell copies of the Software, and to permit 
 persons to whom the Software is furnished to do so, subject to the following conditions:
 
 * Redistributions of source code must retain the above copyright notice, this list of 
   conditions and the following disclaimers.
 
 * Redistributions in binary form must reproduce the above copyright notice, this list of 
   conditions and the following disclaimers in the documentation and/or other materials 
   provided with the distribution.
 
 * Neither the names of Innovative Systems Lab and National Center for Supercomputing 
   Applications, nor the names of its contributors may be used to endorse or promote 
   products derived from this Software without specific prior written permission.
 
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
   INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE 
   LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT 
   OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
   DEALINGS WITH THE SOFTWARE.
 */

vector unsigned char double_shuf_table1[] = {
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  { 24,  25,  26,  27,    28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128},
  { 16,  17,  18,  19,    20,  21,  22,  23,   128, 128, 128, 128,   128, 128, 128, 128},
  { 16,  17,  18,  19,    20,  21,  22,  23,    24,  25,  26,  27,    28,  29,  30,  31},
  {  0,   1,   2,   3,     4,   5,   6,   7,   128, 128, 128, 128,   128, 128, 128, 128},
  {  0,   1,   2,   3,     4,   5,   6,   7,    24,  25,  26,  27,    28,  29,  30,  31},
  {  0,   1,   2,   3,     4,   5,   6,   7,    16,  17,  18,  19,    20,  21,  22,  23},
  {  0,   1,   2,   3,     4,   5,   6,   7,    16,  17,  18,  19,    20,  21,  22,  23},
  {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    12,  13,  14,  15},
  {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    12,  13,  14,  15},
  {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    12,  13,  14,  15},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    12,  13,  14,  15},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  { 24,  25,  26,  27,    28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128},
};

vector unsigned char double_shuf_table2[] = {
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  { 24,  25,  26,  27,    28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  { 24,  25,  26,  27,    28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128},
  { 16,  17,  18,  19,    20,  21,  22,  23,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {  0,   1,   2,   3,     4,   5,   6,   7,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
};

vector unsigned char double_shuf_table3[] = {
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    12,  13,  14,  15},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    12,  13,  14,  15},
  {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    12,  13,  14,  15},
  {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    12,  13,  14,  15},
};

vector unsigned char double_shuf_table4[] = {
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  { 16,  17,  18,  19,    20,  21,  22,  23,    24,  25,  26,  27,    28,  29,  30,  31},
  {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
  {  0,   1,   2,   3,     4,   5,   6,   7,    24,  25,  26,  27,    28,  29,  30,  31},
  {  0,   1,   2,   3,     4,   5,   6,   7,    16,  17,  18,  19,    20,  21,  22,  23},
  {  0,   1,   2,   3,     4,   5,   6,   7,    16,  17,  18,  19,    20,  21,  22,  23},
};



vector unsigned char shuffle_table1[64] =  {
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 24,  25,  26,  27,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 24,  25,  26,  27,    28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128},
    { 20,  21,  22,  23,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 20,  21,  22,  23,    28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128},
    { 20,  21,  22,  23,    24,  25,  26,  27,   128, 128, 128, 128,   128, 128, 128, 128},
    { 20,  21,  22,  23,    24,  25,  26,  27,    28,  29,  30,  31,   128, 128, 128, 128},
    { 16,  17,  18,  19,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 16,  17,  18,  19,    28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128},
    { 16,  17,  18,  19,    24,  25,  26,  27,   128, 128, 128, 128,   128, 128, 128, 128},
    { 16,  17,  18,  19,    24,  25,  26,  27,    28,  29,  30,  31,   128, 128, 128, 128},
    { 16,  17,  18,  19,    20,  21,  22,  23,   128, 128, 128, 128,   128, 128, 128, 128},
    { 16,  17,  18,  19,    20,  21,  22,  23,    28,  29,  30,  31,   128, 128, 128, 128},
    { 16,  17,  18,  19,    20,  21,  22,  23,    24,  25,  26,  27,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,    28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,    24,  25,  26,  27,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,    24,  25,  26,  27,    28,  29,  30,  31,   128, 128, 128, 128},
    {  0,   1,   2,   3,    20,  21,  22,  23,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,    20,  21,  22,  23,    28,  29,  30,  31,   128, 128, 128, 128},
    {  0,   1,   2,   3,    20,  21,  22,  23,    24,  25,  26,  27,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,    16,  17,  18,  19,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,    16,  17,  18,  19,    28,  29,  30,  31,   128, 128, 128, 128},
    {  0,   1,   2,   3,    16,  17,  18,  19,    24,  25,  26,  27,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,    16,  17,  18,  19,    20,  21,  22,  23,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,     4,   5,   6,   7,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,     4,   5,   6,   7,    28,  29,  30,  31,   128, 128, 128, 128},
    {  0,   1,   2,   3,     4,   5,   6,   7,    24,  25,  26,  27,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,     4,   5,   6,   7,    20,  21,  22,  23,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,     4,   5,   6,   7,    16,  17,  18,  19,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 24,  25,  26,  27,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 24,  25,  26,  27,    28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 24,  25,  26,  27,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 24,  25,  26,  27,    28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 24,  25,  26,  27,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 24,  25,  26,  27,    28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128},
    { 20,  21,  22,  23,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 20,  21,  22,  23,    28,  29,  30,  31,   128, 128, 128, 128,   128, 128, 128, 128},
    { 20,  21,  22,  23,    24,  25,  26,  27,   128, 128, 128, 128,   128, 128, 128, 128},
    { 20,  21,  22,  23,    24,  25,  26,  27,    28,  29,  30,  31,   128, 128, 128, 128},
};

vector unsigned char shuffle_table2[64] = {
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    { 16,  17,  18,  19,    20,  21,  22,  23,    24,  25,  26,  27,    28,  29,  30,  31},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,    20,  21,  22,  23,    24,  25,  26,  27,    28,  29,  30,  31},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,    16,  17,  18,  19,    24,  25,  26,  27,    28,  29,  30,  31},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,    16,  17,  18,  19,    20,  21,  22,  23,    28,  29,  30,  31},
    {  0,   1,   2,   3,    16,  17,  18,  19,    20,  21,  22,  23,    24,  25,  26,  27},
    {  0,   1,   2,   3,    16,  17,  18,  19,    20,  21,  22,  23,    24,  25,  26,  27},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,     4,   5,   6,   7,    24,  25,  26,  27,    28,  29,  30,  31},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,     4,   5,   6,   7,    20,  21,  22,  23,    28,  29,  30,  31},
    {  0,   1,   2,   3,     4,   5,   6,   7,    20,  21,  22,  23,    24,  25,  26,  27},
    {  0,   1,   2,   3,     4,   5,   6,   7,    20,  21,  22,  23,    24,  25,  26,  27},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,     4,   5,   6,   7,    16,  17,  18,  19,    28,  29,  30,  31},
    {  0,   1,   2,   3,     4,   5,   6,   7,    16,  17,  18,  19,    24,  25,  26,  27},
    {  0,   1,   2,   3,     4,   5,   6,   7,    16,  17,  18,  19,    24,  25,  26,  27},
    {  0,   1,   2,   3,     4,   5,   6,   7,    16,  17,  18,  19,    20,  21,  22,  23},
    {  0,   1,   2,   3,     4,   5,   6,   7,    16,  17,  18,  19,    20,  21,  22,  23},
    {  0,   1,   2,   3,     4,   5,   6,   7,    16,  17,  18,  19,    20,  21,  22,  23},
    {  0,   1,   2,   3,     4,   5,   6,   7,    16,  17,  18,  19,    20,  21,  22,  23},
    {128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128,   128, 128, 128, 128},
    {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    28,  29,  30,  31},
    {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    24,  25,  26,  27},
    {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    24,  25,  26,  27},
    {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    20,  21,  22,  23},
    {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    20,  21,  22,  23},
    {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    20,  21,  22,  23},
    {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    20,  21,  22,  23},
    {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    16,  17,  18,  19},
    {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    16,  17,  18,  19},
    {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    16,  17,  18,  19},
    {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    16,  17,  18,  19},
    {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    16,  17,  18,  19},
    {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    16,  17,  18,  19},
    {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    16,  17,  18,  19},
    {  0,   1,   2,   3,     4,   5,   6,   7,     8,   9,  10,  11,    16,  17,  18,  19},
};

vector unsigned short large_table[]={
{4,0,0,0,0,0,0,0}, {3,1,0,0,0,0,0,0}, {3,0,1,0,0,0,0,0}, {3,0,0,1,0,0,0,0}, 
{3,0,0,0,1,0,0,0}, {3,0,0,0,0,1,0,0}, {3,0,0,0,0,0,1,0}, {3,0,0,0,0,0,0,1}, 
{3,1,0,0,0,0,0,0}, {2,2,0,0,0,0,0,0}, {2,1,1,0,0,0,0,0}, {2,1,0,1,0,0,0,0}, 
{2,1,0,0,1,0,0,0}, {2,1,0,0,0,1,0,0}, {2,1,0,0,0,0,1,0}, {2,1,0,0,0,0,0,1}, 
{3,0,1,0,0,0,0,0}, {2,1,1,0,0,0,0,0}, {2,0,2,0,0,0,0,0}, {2,0,1,1,0,0,0,0}, 
{2,0,1,0,1,0,0,0}, {2,0,1,0,0,1,0,0}, {2,0,1,0,0,0,1,0}, {2,0,1,0,0,0,0,1}, 
{3,0,0,1,0,0,0,0}, {2,1,0,1,0,0,0,0}, {2,0,1,1,0,0,0,0}, {2,0,0,2,0,0,0,0}, 
{2,0,0,1,1,0,0,0}, {2,0,0,1,0,1,0,0}, {2,0,0,1,0,0,1,0}, {2,0,0,1,0,0,0,1}, 
{3,0,0,0,1,0,0,0}, {2,1,0,0,1,0,0,0}, {2,0,1,0,1,0,0,0}, {2,0,0,1,1,0,0,0}, 
{2,0,0,0,2,0,0,0}, {2,0,0,0,1,1,0,0}, {2,0,0,0,1,0,1,0}, {2,0,0,0,1,0,0,1}, 
{3,0,0,0,0,1,0,0}, {2,1,0,0,0,1,0,0}, {2,0,1,0,0,1,0,0}, {2,0,0,1,0,1,0,0}, 
{2,0,0,0,1,1,0,0}, {2,0,0,0,0,2,0,0}, {2,0,0,0,0,1,1,0}, {2,0,0,0,0,1,0,1}, 
{3,0,0,0,0,0,1,0}, {2,1,0,0,0,0,1,0}, {2,0,1,0,0,0,1,0}, {2,0,0,1,0,0,1,0}, 
{2,0,0,0,1,0,1,0}, {2,0,0,0,0,1,1,0}, {2,0,0,0,0,0,2,0}, {2,0,0,0,0,0,1,1}, 
{3,0,0,0,0,0,0,1}, {2,1,0,0,0,0,0,1}, {2,0,1,0,0,0,0,1}, {2,0,0,1,0,0,0,1}, 
{2,0,0,0,1,0,0,1}, {2,0,0,0,0,1,0,1}, {2,0,0,0,0,0,1,1}, {2,0,0,0,0,0,0,2}, 
{3,1,0,0,0,0,0,0}, {2,2,0,0,0,0,0,0}, {2,1,1,0,0,0,0,0}, {2,1,0,1,0,0,0,0}, 
{2,1,0,0,1,0,0,0}, {2,1,0,0,0,1,0,0}, {2,1,0,0,0,0,1,0}, {2,1,0,0,0,0,0,1}, 
{2,2,0,0,0,0,0,0}, {1,3,0,0,0,0,0,0}, {1,2,1,0,0,0,0,0}, {1,2,0,1,0,0,0,0}, 
{1,2,0,0,1,0,0,0}, {1,2,0,0,0,1,0,0}, {1,2,0,0,0,0,1,0}, {1,2,0,0,0,0,0,1}, 
{2,1,1,0,0,0,0,0}, {1,2,1,0,0,0,0,0}, {1,1,2,0,0,0,0,0}, {1,1,1,1,0,0,0,0}, 
{1,1,1,0,1,0,0,0}, {1,1,1,0,0,1,0,0}, {1,1,1,0,0,0,1,0}, {1,1,1,0,0,0,0,1}, 
{2,1,0,1,0,0,0,0}, {1,2,0,1,0,0,0,0}, {1,1,1,1,0,0,0,0}, {1,1,0,2,0,0,0,0}, 
{1,1,0,1,1,0,0,0}, {1,1,0,1,0,1,0,0}, {1,1,0,1,0,0,1,0}, {1,1,0,1,0,0,0,1}, 
{2,1,0,0,1,0,0,0}, {1,2,0,0,1,0,0,0}, {1,1,1,0,1,0,0,0}, {1,1,0,1,1,0,0,0}, 
{1,1,0,0,2,0,0,0}, {1,1,0,0,1,1,0,0}, {1,1,0,0,1,0,1,0}, {1,1,0,0,1,0,0,1}, 
{2,1,0,0,0,1,0,0}, {1,2,0,0,0,1,0,0}, {1,1,1,0,0,1,0,0}, {1,1,0,1,0,1,0,0}, 
{1,1,0,0,1,1,0,0}, {1,1,0,0,0,2,0,0}, {1,1,0,0,0,1,1,0}, {1,1,0,0,0,1,0,1}, 
{2,1,0,0,0,0,1,0}, {1,2,0,0,0,0,1,0}, {1,1,1,0,0,0,1,0}, {1,1,0,1,0,0,1,0}, 
{1,1,0,0,1,0,1,0}, {1,1,0,0,0,1,1,0}, {1,1,0,0,0,0,2,0}, {1,1,0,0,0,0,1,1}, 
{2,1,0,0,0,0,0,1}, {1,2,0,0,0,0,0,1}, {1,1,1,0,0,0,0,1}, {1,1,0,1,0,0,0,1}, 
{1,1,0,0,1,0,0,1}, {1,1,0,0,0,1,0,1}, {1,1,0,0,0,0,1,1}, {1,1,0,0,0,0,0,2}, 
{3,0,1,0,0,0,0,0}, {2,1,1,0,0,0,0,0}, {2,0,2,0,0,0,0,0}, {2,0,1,1,0,0,0,0}, 
{2,0,1,0,1,0,0,0}, {2,0,1,0,0,1,0,0}, {2,0,1,0,0,0,1,0}, {2,0,1,0,0,0,0,1}, 
{2,1,1,0,0,0,0,0}, {1,2,1,0,0,0,0,0}, {1,1,2,0,0,0,0,0}, {1,1,1,1,0,0,0,0}, 
{1,1,1,0,1,0,0,0}, {1,1,1,0,0,1,0,0}, {1,1,1,0,0,0,1,0}, {1,1,1,0,0,0,0,1}, 
{2,0,2,0,0,0,0,0}, {1,1,2,0,0,0,0,0}, {1,0,3,0,0,0,0,0}, {1,0,2,1,0,0,0,0}, 
{1,0,2,0,1,0,0,0}, {1,0,2,0,0,1,0,0}, {1,0,2,0,0,0,1,0}, {1,0,2,0,0,0,0,1}, 
{2,0,1,1,0,0,0,0}, {1,1,1,1,0,0,0,0}, {1,0,2,1,0,0,0,0}, {1,0,1,2,0,0,0,0}, 
{1,0,1,1,1,0,0,0}, {1,0,1,1,0,1,0,0}, {1,0,1,1,0,0,1,0}, {1,0,1,1,0,0,0,1}, 
{2,0,1,0,1,0,0,0}, {1,1,1,0,1,0,0,0}, {1,0,2,0,1,0,0,0}, {1,0,1,1,1,0,0,0}, 
{1,0,1,0,2,0,0,0}, {1,0,1,0,1,1,0,0}, {1,0,1,0,1,0,1,0}, {1,0,1,0,1,0,0,1}, 
{2,0,1,0,0,1,0,0}, {1,1,1,0,0,1,0,0}, {1,0,2,0,0,1,0,0}, {1,0,1,1,0,1,0,0}, 
{1,0,1,0,1,1,0,0}, {1,0,1,0,0,2,0,0}, {1,0,1,0,0,1,1,0}, {1,0,1,0,0,1,0,1}, 
{2,0,1,0,0,0,1,0}, {1,1,1,0,0,0,1,0}, {1,0,2,0,0,0,1,0}, {1,0,1,1,0,0,1,0}, 
{1,0,1,0,1,0,1,0}, {1,0,1,0,0,1,1,0}, {1,0,1,0,0,0,2,0}, {1,0,1,0,0,0,1,1}, 
{2,0,1,0,0,0,0,1}, {1,1,1,0,0,0,0,1}, {1,0,2,0,0,0,0,1}, {1,0,1,1,0,0,0,1}, 
{1,0,1,0,1,0,0,1}, {1,0,1,0,0,1,0,1}, {1,0,1,0,0,0,1,1}, {1,0,1,0,0,0,0,2}, 
{3,0,0,1,0,0,0,0}, {2,1,0,1,0,0,0,0}, {2,0,1,1,0,0,0,0}, {2,0,0,2,0,0,0,0}, 
{2,0,0,1,1,0,0,0}, {2,0,0,1,0,1,0,0}, {2,0,0,1,0,0,1,0}, {2,0,0,1,0,0,0,1}, 
{2,1,0,1,0,0,0,0}, {1,2,0,1,0,0,0,0}, {1,1,1,1,0,0,0,0}, {1,1,0,2,0,0,0,0}, 
{1,1,0,1,1,0,0,0}, {1,1,0,1,0,1,0,0}, {1,1,0,1,0,0,1,0}, {1,1,0,1,0,0,0,1}, 
{2,0,1,1,0,0,0,0}, {1,1,1,1,0,0,0,0}, {1,0,2,1,0,0,0,0}, {1,0,1,2,0,0,0,0}, 
{1,0,1,1,1,0,0,0}, {1,0,1,1,0,1,0,0}, {1,0,1,1,0,0,1,0}, {1,0,1,1,0,0,0,1}, 
{2,0,0,2,0,0,0,0}, {1,1,0,2,0,0,0,0}, {1,0,1,2,0,0,0,0}, {1,0,0,3,0,0,0,0}, 
{1,0,0,2,1,0,0,0}, {1,0,0,2,0,1,0,0}, {1,0,0,2,0,0,1,0}, {1,0,0,2,0,0,0,1}, 
{2,0,0,1,1,0,0,0}, {1,1,0,1,1,0,0,0}, {1,0,1,1,1,0,0,0}, {1,0,0,2,1,0,0,0}, 
{1,0,0,1,2,0,0,0}, {1,0,0,1,1,1,0,0}, {1,0,0,1,1,0,1,0}, {1,0,0,1,1,0,0,1}, 
{2,0,0,1,0,1,0,0}, {1,1,0,1,0,1,0,0}, {1,0,1,1,0,1,0,0}, {1,0,0,2,0,1,0,0}, 
{1,0,0,1,1,1,0,0}, {1,0,0,1,0,2,0,0}, {1,0,0,1,0,1,1,0}, {1,0,0,1,0,1,0,1}, 
{2,0,0,1,0,0,1,0}, {1,1,0,1,0,0,1,0}, {1,0,1,1,0,0,1,0}, {1,0,0,2,0,0,1,0}, 
{1,0,0,1,1,0,1,0}, {1,0,0,1,0,1,1,0}, {1,0,0,1,0,0,2,0}, {1,0,0,1,0,0,1,1}, 
{2,0,0,1,0,0,0,1}, {1,1,0,1,0,0,0,1}, {1,0,1,1,0,0,0,1}, {1,0,0,2,0,0,0,1}, 
{1,0,0,1,1,0,0,1}, {1,0,0,1,0,1,0,1}, {1,0,0,1,0,0,1,1}, {1,0,0,1,0,0,0,2}, 
{3,0,0,0,1,0,0,0}, {2,1,0,0,1,0,0,0}, {2,0,1,0,1,0,0,0}, {2,0,0,1,1,0,0,0}, 
{2,0,0,0,2,0,0,0}, {2,0,0,0,1,1,0,0}, {2,0,0,0,1,0,1,0}, {2,0,0,0,1,0,0,1}, 
{2,1,0,0,1,0,0,0}, {1,2,0,0,1,0,0,0}, {1,1,1,0,1,0,0,0}, {1,1,0,1,1,0,0,0}, 
{1,1,0,0,2,0,0,0}, {1,1,0,0,1,1,0,0}, {1,1,0,0,1,0,1,0}, {1,1,0,0,1,0,0,1}, 
{2,0,1,0,1,0,0,0}, {1,1,1,0,1,0,0,0}, {1,0,2,0,1,0,0,0}, {1,0,1,1,1,0,0,0}, 
{1,0,1,0,2,0,0,0}, {1,0,1,0,1,1,0,0}, {1,0,1,0,1,0,1,0}, {1,0,1,0,1,0,0,1}, 
{2,0,0,1,1,0,0,0}, {1,1,0,1,1,0,0,0}, {1,0,1,1,1,0,0,0}, {1,0,0,2,1,0,0,0}, 
{1,0,0,1,2,0,0,0}, {1,0,0,1,1,1,0,0}, {1,0,0,1,1,0,1,0}, {1,0,0,1,1,0,0,1}, 
{2,0,0,0,2,0,0,0}, {1,1,0,0,2,0,0,0}, {1,0,1,0,2,0,0,0}, {1,0,0,1,2,0,0,0}, 
{1,0,0,0,3,0,0,0}, {1,0,0,0,2,1,0,0}, {1,0,0,0,2,0,1,0}, {1,0,0,0,2,0,0,1}, 
{2,0,0,0,1,1,0,0}, {1,1,0,0,1,1,0,0}, {1,0,1,0,1,1,0,0}, {1,0,0,1,1,1,0,0}, 
{1,0,0,0,2,1,0,0}, {1,0,0,0,1,2,0,0}, {1,0,0,0,1,1,1,0}, {1,0,0,0,1,1,0,1}, 
{2,0,0,0,1,0,1,0}, {1,1,0,0,1,0,1,0}, {1,0,1,0,1,0,1,0}, {1,0,0,1,1,0,1,0}, 
{1,0,0,0,2,0,1,0}, {1,0,0,0,1,1,1,0}, {1,0,0,0,1,0,2,0}, {1,0,0,0,1,0,1,1}, 
{2,0,0,0,1,0,0,1}, {1,1,0,0,1,0,0,1}, {1,0,1,0,1,0,0,1}, {1,0,0,1,1,0,0,1}, 
{1,0,0,0,2,0,0,1}, {1,0,0,0,1,1,0,1}, {1,0,0,0,1,0,1,1}, {1,0,0,0,1,0,0,2}, 
{3,0,0,0,0,1,0,0}, {2,1,0,0,0,1,0,0}, {2,0,1,0,0,1,0,0}, {2,0,0,1,0,1,0,0}, 
{2,0,0,0,1,1,0,0}, {2,0,0,0,0,2,0,0}, {2,0,0,0,0,1,1,0}, {2,0,0,0,0,1,0,1}, 
{2,1,0,0,0,1,0,0}, {1,2,0,0,0,1,0,0}, {1,1,1,0,0,1,0,0}, {1,1,0,1,0,1,0,0}, 
{1,1,0,0,1,1,0,0}, {1,1,0,0,0,2,0,0}, {1,1,0,0,0,1,1,0}, {1,1,0,0,0,1,0,1}, 
{2,0,1,0,0,1,0,0}, {1,1,1,0,0,1,0,0}, {1,0,2,0,0,1,0,0}, {1,0,1,1,0,1,0,0}, 
{1,0,1,0,1,1,0,0}, {1,0,1,0,0,2,0,0}, {1,0,1,0,0,1,1,0}, {1,0,1,0,0,1,0,1}, 
{2,0,0,1,0,1,0,0}, {1,1,0,1,0,1,0,0}, {1,0,1,1,0,1,0,0}, {1,0,0,2,0,1,0,0}, 
{1,0,0,1,1,1,0,0}, {1,0,0,1,0,2,0,0}, {1,0,0,1,0,1,1,0}, {1,0,0,1,0,1,0,1}, 
{2,0,0,0,1,1,0,0}, {1,1,0,0,1,1,0,0}, {1,0,1,0,1,1,0,0}, {1,0,0,1,1,1,0,0}, 
{1,0,0,0,2,1,0,0}, {1,0,0,0,1,2,0,0}, {1,0,0,0,1,1,1,0}, {1,0,0,0,1,1,0,1}, 
{2,0,0,0,0,2,0,0}, {1,1,0,0,0,2,0,0}, {1,0,1,0,0,2,0,0}, {1,0,0,1,0,2,0,0}, 
{1,0,0,0,1,2,0,0}, {1,0,0,0,0,3,0,0}, {1,0,0,0,0,2,1,0}, {1,0,0,0,0,2,0,1}, 
{2,0,0,0,0,1,1,0}, {1,1,0,0,0,1,1,0}, {1,0,1,0,0,1,1,0}, {1,0,0,1,0,1,1,0}, 
{1,0,0,0,1,1,1,0}, {1,0,0,0,0,2,1,0}, {1,0,0,0,0,1,2,0}, {1,0,0,0,0,1,1,1}, 
{2,0,0,0,0,1,0,1}, {1,1,0,0,0,1,0,1}, {1,0,1,0,0,1,0,1}, {1,0,0,1,0,1,0,1}, 
{1,0,0,0,1,1,0,1}, {1,0,0,0,0,2,0,1}, {1,0,0,0,0,1,1,1}, {1,0,0,0,0,1,0,2}, 
{3,0,0,0,0,0,1,0}, {2,1,0,0,0,0,1,0}, {2,0,1,0,0,0,1,0}, {2,0,0,1,0,0,1,0}, 
{2,0,0,0,1,0,1,0}, {2,0,0,0,0,1,1,0}, {2,0,0,0,0,0,2,0}, {2,0,0,0,0,0,1,1}, 
{2,1,0,0,0,0,1,0}, {1,2,0,0,0,0,1,0}, {1,1,1,0,0,0,1,0}, {1,1,0,1,0,0,1,0}, 
{1,1,0,0,1,0,1,0}, {1,1,0,0,0,1,1,0}, {1,1,0,0,0,0,2,0}, {1,1,0,0,0,0,1,1}, 
{2,0,1,0,0,0,1,0}, {1,1,1,0,0,0,1,0}, {1,0,2,0,0,0,1,0}, {1,0,1,1,0,0,1,0}, 
{1,0,1,0,1,0,1,0}, {1,0,1,0,0,1,1,0}, {1,0,1,0,0,0,2,0}, {1,0,1,0,0,0,1,1}, 
{2,0,0,1,0,0,1,0}, {1,1,0,1,0,0,1,0}, {1,0,1,1,0,0,1,0}, {1,0,0,2,0,0,1,0}, 
{1,0,0,1,1,0,1,0}, {1,0,0,1,0,1,1,0}, {1,0,0,1,0,0,2,0}, {1,0,0,1,0,0,1,1}, 
{2,0,0,0,1,0,1,0}, {1,1,0,0,1,0,1,0}, {1,0,1,0,1,0,1,0}, {1,0,0,1,1,0,1,0}, 
{1,0,0,0,2,0,1,0}, {1,0,0,0,1,1,1,0}, {1,0,0,0,1,0,2,0}, {1,0,0,0,1,0,1,1}, 
{2,0,0,0,0,1,1,0}, {1,1,0,0,0,1,1,0}, {1,0,1,0,0,1,1,0}, {1,0,0,1,0,1,1,0}, 
{1,0,0,0,1,1,1,0}, {1,0,0,0,0,2,1,0}, {1,0,0,0,0,1,2,0}, {1,0,0,0,0,1,1,1}, 
{2,0,0,0,0,0,2,0}, {1,1,0,0,0,0,2,0}, {1,0,1,0,0,0,2,0}, {1,0,0,1,0,0,2,0}, 
{1,0,0,0,1,0,2,0}, {1,0,0,0,0,1,2,0}, {1,0,0,0,0,0,3,0}, {1,0,0,0,0,0,2,1}, 
{2,0,0,0,0,0,1,1}, {1,1,0,0,0,0,1,1}, {1,0,1,0,0,0,1,1}, {1,0,0,1,0,0,1,1}, 
{1,0,0,0,1,0,1,1}, {1,0,0,0,0,1,1,1}, {1,0,0,0,0,0,2,1}, {1,0,0,0,0,0,1,2}, 
{3,0,0,0,0,0,0,1}, {2,1,0,0,0,0,0,1}, {2,0,1,0,0,0,0,1}, {2,0,0,1,0,0,0,1}, 
{2,0,0,0,1,0,0,1}, {2,0,0,0,0,1,0,1}, {2,0,0,0,0,0,1,1}, {2,0,0,0,0,0,0,2}, 
{2,1,0,0,0,0,0,1}, {1,2,0,0,0,0,0,1}, {1,1,1,0,0,0,0,1}, {1,1,0,1,0,0,0,1}, 
{1,1,0,0,1,0,0,1}, {1,1,0,0,0,1,0,1}, {1,1,0,0,0,0,1,1}, {1,1,0,0,0,0,0,2}, 
{2,0,1,0,0,0,0,1}, {1,1,1,0,0,0,0,1}, {1,0,2,0,0,0,0,1}, {1,0,1,1,0,0,0,1}, 
{1,0,1,0,1,0,0,1}, {1,0,1,0,0,1,0,1}, {1,0,1,0,0,0,1,1}, {1,0,1,0,0,0,0,2}, 
{2,0,0,1,0,0,0,1}, {1,1,0,1,0,0,0,1}, {1,0,1,1,0,0,0,1}, {1,0,0,2,0,0,0,1}, 
{1,0,0,1,1,0,0,1}, {1,0,0,1,0,1,0,1}, {1,0,0,1,0,0,1,1}, {1,0,0,1,0,0,0,2}, 
{2,0,0,0,1,0,0,1}, {1,1,0,0,1,0,0,1}, {1,0,1,0,1,0,0,1}, {1,0,0,1,1,0,0,1}, 
{1,0,0,0,2,0,0,1}, {1,0,0,0,1,1,0,1}, {1,0,0,0,1,0,1,1}, {1,0,0,0,1,0,0,2}, 
{2,0,0,0,0,1,0,1}, {1,1,0,0,0,1,0,1}, {1,0,1,0,0,1,0,1}, {1,0,0,1,0,1,0,1}, 
{1,0,0,0,1,1,0,1}, {1,0,0,0,0,2,0,1}, {1,0,0,0,0,1,1,1}, {1,0,0,0,0,1,0,2}, 
{2,0,0,0,0,0,1,1}, {1,1,0,0,0,0,1,1}, {1,0,1,0,0,0,1,1}, {1,0,0,1,0,0,1,1}, 
{1,0,0,0,1,0,1,1}, {1,0,0,0,0,1,1,1}, {1,0,0,0,0,0,2,1}, {1,0,0,0,0,0,1,2}, 
{2,0,0,0,0,0,0,2}, {1,1,0,0,0,0,0,2}, {1,0,1,0,0,0,0,2}, {1,0,0,1,0,0,0,2}, 
{1,0,0,0,1,0,0,2}, {1,0,0,0,0,1,0,2}, {1,0,0,0,0,0,1,2}, {1,0,0,0,0,0,0,3}, 
{3,1,0,0,0,0,0,0}, {2,2,0,0,0,0,0,0}, {2,1,1,0,0,0,0,0}, {2,1,0,1,0,0,0,0}, 
{2,1,0,0,1,0,0,0}, {2,1,0,0,0,1,0,0}, {2,1,0,0,0,0,1,0}, {2,1,0,0,0,0,0,1}, 
{2,2,0,0,0,0,0,0}, {1,3,0,0,0,0,0,0}, {1,2,1,0,0,0,0,0}, {1,2,0,1,0,0,0,0}, 
{1,2,0,0,1,0,0,0}, {1,2,0,0,0,1,0,0}, {1,2,0,0,0,0,1,0}, {1,2,0,0,0,0,0,1}, 
{2,1,1,0,0,0,0,0}, {1,2,1,0,0,0,0,0}, {1,1,2,0,0,0,0,0}, {1,1,1,1,0,0,0,0}, 
{1,1,1,0,1,0,0,0}, {1,1,1,0,0,1,0,0}, {1,1,1,0,0,0,1,0}, {1,1,1,0,0,0,0,1}, 
{2,1,0,1,0,0,0,0}, {1,2,0,1,0,0,0,0}, {1,1,1,1,0,0,0,0}, {1,1,0,2,0,0,0,0}, 
{1,1,0,1,1,0,0,0}, {1,1,0,1,0,1,0,0}, {1,1,0,1,0,0,1,0}, {1,1,0,1,0,0,0,1}, 
{2,1,0,0,1,0,0,0}, {1,2,0,0,1,0,0,0}, {1,1,1,0,1,0,0,0}, {1,1,0,1,1,0,0,0}, 
{1,1,0,0,2,0,0,0}, {1,1,0,0,1,1,0,0}, {1,1,0,0,1,0,1,0}, {1,1,0,0,1,0,0,1}, 
{2,1,0,0,0,1,0,0}, {1,2,0,0,0,1,0,0}, {1,1,1,0,0,1,0,0}, {1,1,0,1,0,1,0,0}, 
{1,1,0,0,1,1,0,0}, {1,1,0,0,0,2,0,0}, {1,1,0,0,0,1,1,0}, {1,1,0,0,0,1,0,1}, 
{2,1,0,0,0,0,1,0}, {1,2,0,0,0,0,1,0}, {1,1,1,0,0,0,1,0}, {1,1,0,1,0,0,1,0}, 
{1,1,0,0,1,0,1,0}, {1,1,0,0,0,1,1,0}, {1,1,0,0,0,0,2,0}, {1,1,0,0,0,0,1,1}, 
{2,1,0,0,0,0,0,1}, {1,2,0,0,0,0,0,1}, {1,1,1,0,0,0,0,1}, {1,1,0,1,0,0,0,1}, 
{1,1,0,0,1,0,0,1}, {1,1,0,0,0,1,0,1}, {1,1,0,0,0,0,1,1}, {1,1,0,0,0,0,0,2}, 
{2,2,0,0,0,0,0,0}, {1,3,0,0,0,0,0,0}, {1,2,1,0,0,0,0,0}, {1,2,0,1,0,0,0,0}, 
{1,2,0,0,1,0,0,0}, {1,2,0,0,0,1,0,0}, {1,2,0,0,0,0,1,0}, {1,2,0,0,0,0,0,1}, 
{1,3,0,0,0,0,0,0}, {0,4,0,0,0,0,0,0}, {0,3,1,0,0,0,0,0}, {0,3,0,1,0,0,0,0}, 
{0,3,0,0,1,0,0,0}, {0,3,0,0,0,1,0,0}, {0,3,0,0,0,0,1,0}, {0,3,0,0,0,0,0,1}, 
{1,2,1,0,0,0,0,0}, {0,3,1,0,0,0,0,0}, {0,2,2,0,0,0,0,0}, {0,2,1,1,0,0,0,0}, 
{0,2,1,0,1,0,0,0}, {0,2,1,0,0,1,0,0}, {0,2,1,0,0,0,1,0}, {0,2,1,0,0,0,0,1}, 
{1,2,0,1,0,0,0,0}, {0,3,0,1,0,0,0,0}, {0,2,1,1,0,0,0,0}, {0,2,0,2,0,0,0,0}, 
{0,2,0,1,1,0,0,0}, {0,2,0,1,0,1,0,0}, {0,2,0,1,0,0,1,0}, {0,2,0,1,0,0,0,1}, 
{1,2,0,0,1,0,0,0}, {0,3,0,0,1,0,0,0}, {0,2,1,0,1,0,0,0}, {0,2,0,1,1,0,0,0}, 
{0,2,0,0,2,0,0,0}, {0,2,0,0,1,1,0,0}, {0,2,0,0,1,0,1,0}, {0,2,0,0,1,0,0,1}, 
{1,2,0,0,0,1,0,0}, {0,3,0,0,0,1,0,0}, {0,2,1,0,0,1,0,0}, {0,2,0,1,0,1,0,0}, 
{0,2,0,0,1,1,0,0}, {0,2,0,0,0,2,0,0}, {0,2,0,0,0,1,1,0}, {0,2,0,0,0,1,0,1}, 
{1,2,0,0,0,0,1,0}, {0,3,0,0,0,0,1,0}, {0,2,1,0,0,0,1,0}, {0,2,0,1,0,0,1,0}, 
{0,2,0,0,1,0,1,0}, {0,2,0,0,0,1,1,0}, {0,2,0,0,0,0,2,0}, {0,2,0,0,0,0,1,1}, 
{1,2,0,0,0,0,0,1}, {0,3,0,0,0,0,0,1}, {0,2,1,0,0,0,0,1}, {0,2,0,1,0,0,0,1}, 
{0,2,0,0,1,0,0,1}, {0,2,0,0,0,1,0,1}, {0,2,0,0,0,0,1,1}, {0,2,0,0,0,0,0,2}, 
{2,1,1,0,0,0,0,0}, {1,2,1,0,0,0,0,0}, {1,1,2,0,0,0,0,0}, {1,1,1,1,0,0,0,0}, 
{1,1,1,0,1,0,0,0}, {1,1,1,0,0,1,0,0}, {1,1,1,0,0,0,1,0}, {1,1,1,0,0,0,0,1}, 
{1,2,1,0,0,0,0,0}, {0,3,1,0,0,0,0,0}, {0,2,2,0,0,0,0,0}, {0,2,1,1,0,0,0,0}, 
{0,2,1,0,1,0,0,0}, {0,2,1,0,0,1,0,0}, {0,2,1,0,0,0,1,0}, {0,2,1,0,0,0,0,1}, 
{1,1,2,0,0,0,0,0}, {0,2,2,0,0,0,0,0}, {0,1,3,0,0,0,0,0}, {0,1,2,1,0,0,0,0}, 
{0,1,2,0,1,0,0,0}, {0,1,2,0,0,1,0,0}, {0,1,2,0,0,0,1,0}, {0,1,2,0,0,0,0,1}, 
{1,1,1,1,0,0,0,0}, {0,2,1,1,0,0,0,0}, {0,1,2,1,0,0,0,0}, {0,1,1,2,0,0,0,0}, 
{0,1,1,1,1,0,0,0}, {0,1,1,1,0,1,0,0}, {0,1,1,1,0,0,1,0}, {0,1,1,1,0,0,0,1}, 
{1,1,1,0,1,0,0,0}, {0,2,1,0,1,0,0,0}, {0,1,2,0,1,0,0,0}, {0,1,1,1,1,0,0,0}, 
{0,1,1,0,2,0,0,0}, {0,1,1,0,1,1,0,0}, {0,1,1,0,1,0,1,0}, {0,1,1,0,1,0,0,1}, 
{1,1,1,0,0,1,0,0}, {0,2,1,0,0,1,0,0}, {0,1,2,0,0,1,0,0}, {0,1,1,1,0,1,0,0}, 
{0,1,1,0,1,1,0,0}, {0,1,1,0,0,2,0,0}, {0,1,1,0,0,1,1,0}, {0,1,1,0,0,1,0,1}, 
{1,1,1,0,0,0,1,0}, {0,2,1,0,0,0,1,0}, {0,1,2,0,0,0,1,0}, {0,1,1,1,0,0,1,0}, 
{0,1,1,0,1,0,1,0}, {0,1,1,0,0,1,1,0}, {0,1,1,0,0,0,2,0}, {0,1,1,0,0,0,1,1}, 
{1,1,1,0,0,0,0,1}, {0,2,1,0,0,0,0,1}, {0,1,2,0,0,0,0,1}, {0,1,1,1,0,0,0,1}, 
{0,1,1,0,1,0,0,1}, {0,1,1,0,0,1,0,1}, {0,1,1,0,0,0,1,1}, {0,1,1,0,0,0,0,2}, 
{2,1,0,1,0,0,0,0}, {1,2,0,1,0,0,0,0}, {1,1,1,1,0,0,0,0}, {1,1,0,2,0,0,0,0}, 
{1,1,0,1,1,0,0,0}, {1,1,0,1,0,1,0,0}, {1,1,0,1,0,0,1,0}, {1,1,0,1,0,0,0,1}, 
{1,2,0,1,0,0,0,0}, {0,3,0,1,0,0,0,0}, {0,2,1,1,0,0,0,0}, {0,2,0,2,0,0,0,0}, 
{0,2,0,1,1,0,0,0}, {0,2,0,1,0,1,0,0}, {0,2,0,1,0,0,1,0}, {0,2,0,1,0,0,0,1}, 
{1,1,1,1,0,0,0,0}, {0,2,1,1,0,0,0,0}, {0,1,2,1,0,0,0,0}, {0,1,1,2,0,0,0,0}, 
{0,1,1,1,1,0,0,0}, {0,1,1,1,0,1,0,0}, {0,1,1,1,0,0,1,0}, {0,1,1,1,0,0,0,1}, 
{1,1,0,2,0,0,0,0}, {0,2,0,2,0,0,0,0}, {0,1,1,2,0,0,0,0}, {0,1,0,3,0,0,0,0}, 
{0,1,0,2,1,0,0,0}, {0,1,0,2,0,1,0,0}, {0,1,0,2,0,0,1,0}, {0,1,0,2,0,0,0,1}, 
{1,1,0,1,1,0,0,0}, {0,2,0,1,1,0,0,0}, {0,1,1,1,1,0,0,0}, {0,1,0,2,1,0,0,0}, 
{0,1,0,1,2,0,0,0}, {0,1,0,1,1,1,0,0}, {0,1,0,1,1,0,1,0}, {0,1,0,1,1,0,0,1}, 
{1,1,0,1,0,1,0,0}, {0,2,0,1,0,1,0,0}, {0,1,1,1,0,1,0,0}, {0,1,0,2,0,1,0,0}, 
{0,1,0,1,1,1,0,0}, {0,1,0,1,0,2,0,0}, {0,1,0,1,0,1,1,0}, {0,1,0,1,0,1,0,1}, 
{1,1,0,1,0,0,1,0}, {0,2,0,1,0,0,1,0}, {0,1,1,1,0,0,1,0}, {0,1,0,2,0,0,1,0}, 
{0,1,0,1,1,0,1,0}, {0,1,0,1,0,1,1,0}, {0,1,0,1,0,0,2,0}, {0,1,0,1,0,0,1,1}, 
{1,1,0,1,0,0,0,1}, {0,2,0,1,0,0,0,1}, {0,1,1,1,0,0,0,1}, {0,1,0,2,0,0,0,1}, 
{0,1,0,1,1,0,0,1}, {0,1,0,1,0,1,0,1}, {0,1,0,1,0,0,1,1}, {0,1,0,1,0,0,0,2}, 
{2,1,0,0,1,0,0,0}, {1,2,0,0,1,0,0,0}, {1,1,1,0,1,0,0,0}, {1,1,0,1,1,0,0,0}, 
{1,1,0,0,2,0,0,0}, {1,1,0,0,1,1,0,0}, {1,1,0,0,1,0,1,0}, {1,1,0,0,1,0,0,1}, 
{1,2,0,0,1,0,0,0}, {0,3,0,0,1,0,0,0}, {0,2,1,0,1,0,0,0}, {0,2,0,1,1,0,0,0}, 
{0,2,0,0,2,0,0,0}, {0,2,0,0,1,1,0,0}, {0,2,0,0,1,0,1,0}, {0,2,0,0,1,0,0,1}, 
{1,1,1,0,1,0,0,0}, {0,2,1,0,1,0,0,0}, {0,1,2,0,1,0,0,0}, {0,1,1,1,1,0,0,0}, 
{0,1,1,0,2,0,0,0}, {0,1,1,0,1,1,0,0}, {0,1,1,0,1,0,1,0}, {0,1,1,0,1,0,0,1}, 
{1,1,0,1,1,0,0,0}, {0,2,0,1,1,0,0,0}, {0,1,1,1,1,0,0,0}, {0,1,0,2,1,0,0,0}, 
{0,1,0,1,2,0,0,0}, {0,1,0,1,1,1,0,0}, {0,1,0,1,1,0,1,0}, {0,1,0,1,1,0,0,1}, 
{1,1,0,0,2,0,0,0}, {0,2,0,0,2,0,0,0}, {0,1,1,0,2,0,0,0}, {0,1,0,1,2,0,0,0}, 
{0,1,0,0,3,0,0,0}, {0,1,0,0,2,1,0,0}, {0,1,0,0,2,0,1,0}, {0,1,0,0,2,0,0,1}, 
{1,1,0,0,1,1,0,0}, {0,2,0,0,1,1,0,0}, {0,1,1,0,1,1,0,0}, {0,1,0,1,1,1,0,0}, 
{0,1,0,0,2,1,0,0}, {0,1,0,0,1,2,0,0}, {0,1,0,0,1,1,1,0}, {0,1,0,0,1,1,0,1}, 
{1,1,0,0,1,0,1,0}, {0,2,0,0,1,0,1,0}, {0,1,1,0,1,0,1,0}, {0,1,0,1,1,0,1,0}, 
{0,1,0,0,2,0,1,0}, {0,1,0,0,1,1,1,0}, {0,1,0,0,1,0,2,0}, {0,1,0,0,1,0,1,1}, 
{1,1,0,0,1,0,0,1}, {0,2,0,0,1,0,0,1}, {0,1,1,0,1,0,0,1}, {0,1,0,1,1,0,0,1}, 
{0,1,0,0,2,0,0,1}, {0,1,0,0,1,1,0,1}, {0,1,0,0,1,0,1,1}, {0,1,0,0,1,0,0,2}, 
{2,1,0,0,0,1,0,0}, {1,2,0,0,0,1,0,0}, {1,1,1,0,0,1,0,0}, {1,1,0,1,0,1,0,0}, 
{1,1,0,0,1,1,0,0}, {1,1,0,0,0,2,0,0}, {1,1,0,0,0,1,1,0}, {1,1,0,0,0,1,0,1}, 
{1,2,0,0,0,1,0,0}, {0,3,0,0,0,1,0,0}, {0,2,1,0,0,1,0,0}, {0,2,0,1,0,1,0,0}, 
{0,2,0,0,1,1,0,0}, {0,2,0,0,0,2,0,0}, {0,2,0,0,0,1,1,0}, {0,2,0,0,0,1,0,1}, 
{1,1,1,0,0,1,0,0}, {0,2,1,0,0,1,0,0}, {0,1,2,0,0,1,0,0}, {0,1,1,1,0,1,0,0}, 
{0,1,1,0,1,1,0,0}, {0,1,1,0,0,2,0,0}, {0,1,1,0,0,1,1,0}, {0,1,1,0,0,1,0,1}, 
{1,1,0,1,0,1,0,0}, {0,2,0,1,0,1,0,0}, {0,1,1,1,0,1,0,0}, {0,1,0,2,0,1,0,0}, 
{0,1,0,1,1,1,0,0}, {0,1,0,1,0,2,0,0}, {0,1,0,1,0,1,1,0}, {0,1,0,1,0,1,0,1}, 
{1,1,0,0,1,1,0,0}, {0,2,0,0,1,1,0,0}, {0,1,1,0,1,1,0,0}, {0,1,0,1,1,1,0,0}, 
{0,1,0,0,2,1,0,0}, {0,1,0,0,1,2,0,0}, {0,1,0,0,1,1,1,0}, {0,1,0,0,1,1,0,1}, 
{1,1,0,0,0,2,0,0}, {0,2,0,0,0,2,0,0}, {0,1,1,0,0,2,0,0}, {0,1,0,1,0,2,0,0}, 
{0,1,0,0,1,2,0,0}, {0,1,0,0,0,3,0,0}, {0,1,0,0,0,2,1,0}, {0,1,0,0,0,2,0,1}, 
{1,1,0,0,0,1,1,0}, {0,2,0,0,0,1,1,0}, {0,1,1,0,0,1,1,0}, {0,1,0,1,0,1,1,0}, 
{0,1,0,0,1,1,1,0}, {0,1,0,0,0,2,1,0}, {0,1,0,0,0,1,2,0}, {0,1,0,0,0,1,1,1}, 
{1,1,0,0,0,1,0,1}, {0,2,0,0,0,1,0,1}, {0,1,1,0,0,1,0,1}, {0,1,0,1,0,1,0,1}, 
{0,1,0,0,1,1,0,1}, {0,1,0,0,0,2,0,1}, {0,1,0,0,0,1,1,1}, {0,1,0,0,0,1,0,2}, 
{2,1,0,0,0,0,1,0}, {1,2,0,0,0,0,1,0}, {1,1,1,0,0,0,1,0}, {1,1,0,1,0,0,1,0}, 
{1,1,0,0,1,0,1,0}, {1,1,0,0,0,1,1,0}, {1,1,0,0,0,0,2,0}, {1,1,0,0,0,0,1,1}, 
{1,2,0,0,0,0,1,0}, {0,3,0,0,0,0,1,0}, {0,2,1,0,0,0,1,0}, {0,2,0,1,0,0,1,0}, 
{0,2,0,0,1,0,1,0}, {0,2,0,0,0,1,1,0}, {0,2,0,0,0,0,2,0}, {0,2,0,0,0,0,1,1}, 
{1,1,1,0,0,0,1,0}, {0,2,1,0,0,0,1,0}, {0,1,2,0,0,0,1,0}, {0,1,1,1,0,0,1,0}, 
{0,1,1,0,1,0,1,0}, {0,1,1,0,0,1,1,0}, {0,1,1,0,0,0,2,0}, {0,1,1,0,0,0,1,1}, 
{1,1,0,1,0,0,1,0}, {0,2,0,1,0,0,1,0}, {0,1,1,1,0,0,1,0}, {0,1,0,2,0,0,1,0}, 
{0,1,0,1,1,0,1,0}, {0,1,0,1,0,1,1,0}, {0,1,0,1,0,0,2,0}, {0,1,0,1,0,0,1,1}, 
{1,1,0,0,1,0,1,0}, {0,2,0,0,1,0,1,0}, {0,1,1,0,1,0,1,0}, {0,1,0,1,1,0,1,0}, 
{0,1,0,0,2,0,1,0}, {0,1,0,0,1,1,1,0}, {0,1,0,0,1,0,2,0}, {0,1,0,0,1,0,1,1}, 
{1,1,0,0,0,1,1,0}, {0,2,0,0,0,1,1,0}, {0,1,1,0,0,1,1,0}, {0,1,0,1,0,1,1,0}, 
{0,1,0,0,1,1,1,0}, {0,1,0,0,0,2,1,0}, {0,1,0,0,0,1,2,0}, {0,1,0,0,0,1,1,1}, 
{1,1,0,0,0,0,2,0}, {0,2,0,0,0,0,2,0}, {0,1,1,0,0,0,2,0}, {0,1,0,1,0,0,2,0}, 
{0,1,0,0,1,0,2,0}, {0,1,0,0,0,1,2,0}, {0,1,0,0,0,0,3,0}, {0,1,0,0,0,0,2,1}, 
{1,1,0,0,0,0,1,1}, {0,2,0,0,0,0,1,1}, {0,1,1,0,0,0,1,1}, {0,1,0,1,0,0,1,1}, 
{0,1,0,0,1,0,1,1}, {0,1,0,0,0,1,1,1}, {0,1,0,0,0,0,2,1}, {0,1,0,0,0,0,1,2}, 
{2,1,0,0,0,0,0,1}, {1,2,0,0,0,0,0,1}, {1,1,1,0,0,0,0,1}, {1,1,0,1,0,0,0,1}, 
{1,1,0,0,1,0,0,1}, {1,1,0,0,0,1,0,1}, {1,1,0,0,0,0,1,1}, {1,1,0,0,0,0,0,2}, 
{1,2,0,0,0,0,0,1}, {0,3,0,0,0,0,0,1}, {0,2,1,0,0,0,0,1}, {0,2,0,1,0,0,0,1}, 
{0,2,0,0,1,0,0,1}, {0,2,0,0,0,1,0,1}, {0,2,0,0,0,0,1,1}, {0,2,0,0,0,0,0,2}, 
{1,1,1,0,0,0,0,1}, {0,2,1,0,0,0,0,1}, {0,1,2,0,0,0,0,1}, {0,1,1,1,0,0,0,1}, 
{0,1,1,0,1,0,0,1}, {0,1,1,0,0,1,0,1}, {0,1,1,0,0,0,1,1}, {0,1,1,0,0,0,0,2}, 
{1,1,0,1,0,0,0,1}, {0,2,0,1,0,0,0,1}, {0,1,1,1,0,0,0,1}, {0,1,0,2,0,0,0,1}, 
{0,1,0,1,1,0,0,1}, {0,1,0,1,0,1,0,1}, {0,1,0,1,0,0,1,1}, {0,1,0,1,0,0,0,2}, 
{1,1,0,0,1,0,0,1}, {0,2,0,0,1,0,0,1}, {0,1,1,0,1,0,0,1}, {0,1,0,1,1,0,0,1}, 
{0,1,0,0,2,0,0,1}, {0,1,0,0,1,1,0,1}, {0,1,0,0,1,0,1,1}, {0,1,0,0,1,0,0,2}, 
{1,1,0,0,0,1,0,1}, {0,2,0,0,0,1,0,1}, {0,1,1,0,0,1,0,1}, {0,1,0,1,0,1,0,1}, 
{0,1,0,0,1,1,0,1}, {0,1,0,0,0,2,0,1}, {0,1,0,0,0,1,1,1}, {0,1,0,0,0,1,0,2}, 
{1,1,0,0,0,0,1,1}, {0,2,0,0,0,0,1,1}, {0,1,1,0,0,0,1,1}, {0,1,0,1,0,0,1,1}, 
{0,1,0,0,1,0,1,1}, {0,1,0,0,0,1,1,1}, {0,1,0,0,0,0,2,1}, {0,1,0,0,0,0,1,2}, 
{1,1,0,0,0,0,0,2}, {0,2,0,0,0,0,0,2}, {0,1,1,0,0,0,0,2}, {0,1,0,1,0,0,0,2}, 
{0,1,0,0,1,0,0,2}, {0,1,0,0,0,1,0,2}, {0,1,0,0,0,0,1,2}, {0,1,0,0,0,0,0,3}, 
{3,0,1,0,0,0,0,0}, {2,1,1,0,0,0,0,0}, {2,0,2,0,0,0,0,0}, {2,0,1,1,0,0,0,0}, 
{2,0,1,0,1,0,0,0}, {2,0,1,0,0,1,0,0}, {2,0,1,0,0,0,1,0}, {2,0,1,0,0,0,0,1}, 
{2,1,1,0,0,0,0,0}, {1,2,1,0,0,0,0,0}, {1,1,2,0,0,0,0,0}, {1,1,1,1,0,0,0,0}, 
{1,1,1,0,1,0,0,0}, {1,1,1,0,0,1,0,0}, {1,1,1,0,0,0,1,0}, {1,1,1,0,0,0,0,1}, 
{2,0,2,0,0,0,0,0}, {1,1,2,0,0,0,0,0}, {1,0,3,0,0,0,0,0}, {1,0,2,1,0,0,0,0}, 
{1,0,2,0,1,0,0,0}, {1,0,2,0,0,1,0,0}, {1,0,2,0,0,0,1,0}, {1,0,2,0,0,0,0,1}, 
{2,0,1,1,0,0,0,0}, {1,1,1,1,0,0,0,0}, {1,0,2,1,0,0,0,0}, {1,0,1,2,0,0,0,0}, 
{1,0,1,1,1,0,0,0}, {1,0,1,1,0,1,0,0}, {1,0,1,1,0,0,1,0}, {1,0,1,1,0,0,0,1}, 
{2,0,1,0,1,0,0,0}, {1,1,1,0,1,0,0,0}, {1,0,2,0,1,0,0,0}, {1,0,1,1,1,0,0,0}, 
{1,0,1,0,2,0,0,0}, {1,0,1,0,1,1,0,0}, {1,0,1,0,1,0,1,0}, {1,0,1,0,1,0,0,1}, 
{2,0,1,0,0,1,0,0}, {1,1,1,0,0,1,0,0}, {1,0,2,0,0,1,0,0}, {1,0,1,1,0,1,0,0}, 
{1,0,1,0,1,1,0,0}, {1,0,1,0,0,2,0,0}, {1,0,1,0,0,1,1,0}, {1,0,1,0,0,1,0,1}, 
{2,0,1,0,0,0,1,0}, {1,1,1,0,0,0,1,0}, {1,0,2,0,0,0,1,0}, {1,0,1,1,0,0,1,0}, 
{1,0,1,0,1,0,1,0}, {1,0,1,0,0,1,1,0}, {1,0,1,0,0,0,2,0}, {1,0,1,0,0,0,1,1}, 
{2,0,1,0,0,0,0,1}, {1,1,1,0,0,0,0,1}, {1,0,2,0,0,0,0,1}, {1,0,1,1,0,0,0,1}, 
{1,0,1,0,1,0,0,1}, {1,0,1,0,0,1,0,1}, {1,0,1,0,0,0,1,1}, {1,0,1,0,0,0,0,2}, 
{2,1,1,0,0,0,0,0}, {1,2,1,0,0,0,0,0}, {1,1,2,0,0,0,0,0}, {1,1,1,1,0,0,0,0}, 
{1,1,1,0,1,0,0,0}, {1,1,1,0,0,1,0,0}, {1,1,1,0,0,0,1,0}, {1,1,1,0,0,0,0,1}, 
{1,2,1,0,0,0,0,0}, {0,3,1,0,0,0,0,0}, {0,2,2,0,0,0,0,0}, {0,2,1,1,0,0,0,0}, 
{0,2,1,0,1,0,0,0}, {0,2,1,0,0,1,0,0}, {0,2,1,0,0,0,1,0}, {0,2,1,0,0,0,0,1}, 
{1,1,2,0,0,0,0,0}, {0,2,2,0,0,0,0,0}, {0,1,3,0,0,0,0,0}, {0,1,2,1,0,0,0,0}, 
{0,1,2,0,1,0,0,0}, {0,1,2,0,0,1,0,0}, {0,1,2,0,0,0,1,0}, {0,1,2,0,0,0,0,1}, 
{1,1,1,1,0,0,0,0}, {0,2,1,1,0,0,0,0}, {0,1,2,1,0,0,0,0}, {0,1,1,2,0,0,0,0}, 
{0,1,1,1,1,0,0,0}, {0,1,1,1,0,1,0,0}, {0,1,1,1,0,0,1,0}, {0,1,1,1,0,0,0,1}, 
{1,1,1,0,1,0,0,0}, {0,2,1,0,1,0,0,0}, {0,1,2,0,1,0,0,0}, {0,1,1,1,1,0,0,0}, 
{0,1,1,0,2,0,0,0}, {0,1,1,0,1,1,0,0}, {0,1,1,0,1,0,1,0}, {0,1,1,0,1,0,0,1}, 
{1,1,1,0,0,1,0,0}, {0,2,1,0,0,1,0,0}, {0,1,2,0,0,1,0,0}, {0,1,1,1,0,1,0,0}, 
{0,1,1,0,1,1,0,0}, {0,1,1,0,0,2,0,0}, {0,1,1,0,0,1,1,0}, {0,1,1,0,0,1,0,1}, 
{1,1,1,0,0,0,1,0}, {0,2,1,0,0,0,1,0}, {0,1,2,0,0,0,1,0}, {0,1,1,1,0,0,1,0}, 
{0,1,1,0,1,0,1,0}, {0,1,1,0,0,1,1,0}, {0,1,1,0,0,0,2,0}, {0,1,1,0,0,0,1,1}, 
{1,1,1,0,0,0,0,1}, {0,2,1,0,0,0,0,1}, {0,1,2,0,0,0,0,1}, {0,1,1,1,0,0,0,1}, 
{0,1,1,0,1,0,0,1}, {0,1,1,0,0,1,0,1}, {0,1,1,0,0,0,1,1}, {0,1,1,0,0,0,0,2}, 
{2,0,2,0,0,0,0,0}, {1,1,2,0,0,0,0,0}, {1,0,3,0,0,0,0,0}, {1,0,2,1,0,0,0,0}, 
{1,0,2,0,1,0,0,0}, {1,0,2,0,0,1,0,0}, {1,0,2,0,0,0,1,0}, {1,0,2,0,0,0,0,1}, 
{1,1,2,0,0,0,0,0}, {0,2,2,0,0,0,0,0}, {0,1,3,0,0,0,0,0}, {0,1,2,1,0,0,0,0}, 
{0,1,2,0,1,0,0,0}, {0,1,2,0,0,1,0,0}, {0,1,2,0,0,0,1,0}, {0,1,2,0,0,0,0,1}, 
{1,0,3,0,0,0,0,0}, {0,1,3,0,0,0,0,0}, {0,0,4,0,0,0,0,0}, {0,0,3,1,0,0,0,0}, 
{0,0,3,0,1,0,0,0}, {0,0,3,0,0,1,0,0}, {0,0,3,0,0,0,1,0}, {0,0,3,0,0,0,0,1}, 
{1,0,2,1,0,0,0,0}, {0,1,2,1,0,0,0,0}, {0,0,3,1,0,0,0,0}, {0,0,2,2,0,0,0,0}, 
{0,0,2,1,1,0,0,0}, {0,0,2,1,0,1,0,0}, {0,0,2,1,0,0,1,0}, {0,0,2,1,0,0,0,1}, 
{1,0,2,0,1,0,0,0}, {0,1,2,0,1,0,0,0}, {0,0,3,0,1,0,0,0}, {0,0,2,1,1,0,0,0}, 
{0,0,2,0,2,0,0,0}, {0,0,2,0,1,1,0,0}, {0,0,2,0,1,0,1,0}, {0,0,2,0,1,0,0,1}, 
{1,0,2,0,0,1,0,0}, {0,1,2,0,0,1,0,0}, {0,0,3,0,0,1,0,0}, {0,0,2,1,0,1,0,0}, 
{0,0,2,0,1,1,0,0}, {0,0,2,0,0,2,0,0}, {0,0,2,0,0,1,1,0}, {0,0,2,0,0,1,0,1}, 
{1,0,2,0,0,0,1,0}, {0,1,2,0,0,0,1,0}, {0,0,3,0,0,0,1,0}, {0,0,2,1,0,0,1,0}, 
{0,0,2,0,1,0,1,0}, {0,0,2,0,0,1,1,0}, {0,0,2,0,0,0,2,0}, {0,0,2,0,0,0,1,1}, 
{1,0,2,0,0,0,0,1}, {0,1,2,0,0,0,0,1}, {0,0,3,0,0,0,0,1}, {0,0,2,1,0,0,0,1}, 
{0,0,2,0,1,0,0,1}, {0,0,2,0,0,1,0,1}, {0,0,2,0,0,0,1,1}, {0,0,2,0,0,0,0,2}, 
{2,0,1,1,0,0,0,0}, {1,1,1,1,0,0,0,0}, {1,0,2,1,0,0,0,0}, {1,0,1,2,0,0,0,0}, 
{1,0,1,1,1,0,0,0}, {1,0,1,1,0,1,0,0}, {1,0,1,1,0,0,1,0}, {1,0,1,1,0,0,0,1}, 
{1,1,1,1,0,0,0,0}, {0,2,1,1,0,0,0,0}, {0,1,2,1,0,0,0,0}, {0,1,1,2,0,0,0,0}, 
{0,1,1,1,1,0,0,0}, {0,1,1,1,0,1,0,0}, {0,1,1,1,0,0,1,0}, {0,1,1,1,0,0,0,1}, 
{1,0,2,1,0,0,0,0}, {0,1,2,1,0,0,0,0}, {0,0,3,1,0,0,0,0}, {0,0,2,2,0,0,0,0}, 
{0,0,2,1,1,0,0,0}, {0,0,2,1,0,1,0,0}, {0,0,2,1,0,0,1,0}, {0,0,2,1,0,0,0,1}, 
{1,0,1,2,0,0,0,0}, {0,1,1,2,0,0,0,0}, {0,0,2,2,0,0,0,0}, {0,0,1,3,0,0,0,0}, 
{0,0,1,2,1,0,0,0}, {0,0,1,2,0,1,0,0}, {0,0,1,2,0,0,1,0}, {0,0,1,2,0,0,0,1}, 
{1,0,1,1,1,0,0,0}, {0,1,1,1,1,0,0,0}, {0,0,2,1,1,0,0,0}, {0,0,1,2,1,0,0,0}, 
{0,0,1,1,2,0,0,0}, {0,0,1,1,1,1,0,0}, {0,0,1,1,1,0,1,0}, {0,0,1,1,1,0,0,1}, 
{1,0,1,1,0,1,0,0}, {0,1,1,1,0,1,0,0}, {0,0,2,1,0,1,0,0}, {0,0,1,2,0,1,0,0}, 
{0,0,1,1,1,1,0,0}, {0,0,1,1,0,2,0,0}, {0,0,1,1,0,1,1,0}, {0,0,1,1,0,1,0,1}, 
{1,0,1,1,0,0,1,0}, {0,1,1,1,0,0,1,0}, {0,0,2,1,0,0,1,0}, {0,0,1,2,0,0,1,0}, 
{0,0,1,1,1,0,1,0}, {0,0,1,1,0,1,1,0}, {0,0,1,1,0,0,2,0}, {0,0,1,1,0,0,1,1}, 
{1,0,1,1,0,0,0,1}, {0,1,1,1,0,0,0,1}, {0,0,2,1,0,0,0,1}, {0,0,1,2,0,0,0,1}, 
{0,0,1,1,1,0,0,1}, {0,0,1,1,0,1,0,1}, {0,0,1,1,0,0,1,1}, {0,0,1,1,0,0,0,2}, 
{2,0,1,0,1,0,0,0}, {1,1,1,0,1,0,0,0}, {1,0,2,0,1,0,0,0}, {1,0,1,1,1,0,0,0}, 
{1,0,1,0,2,0,0,0}, {1,0,1,0,1,1,0,0}, {1,0,1,0,1,0,1,0}, {1,0,1,0,1,0,0,1}, 
{1,1,1,0,1,0,0,0}, {0,2,1,0,1,0,0,0}, {0,1,2,0,1,0,0,0}, {0,1,1,1,1,0,0,0}, 
{0,1,1,0,2,0,0,0}, {0,1,1,0,1,1,0,0}, {0,1,1,0,1,0,1,0}, {0,1,1,0,1,0,0,1}, 
{1,0,2,0,1,0,0,0}, {0,1,2,0,1,0,0,0}, {0,0,3,0,1,0,0,0}, {0,0,2,1,1,0,0,0}, 
{0,0,2,0,2,0,0,0}, {0,0,2,0,1,1,0,0}, {0,0,2,0,1,0,1,0}, {0,0,2,0,1,0,0,1}, 
{1,0,1,1,1,0,0,0}, {0,1,1,1,1,0,0,0}, {0,0,2,1,1,0,0,0}, {0,0,1,2,1,0,0,0}, 
{0,0,1,1,2,0,0,0}, {0,0,1,1,1,1,0,0}, {0,0,1,1,1,0,1,0}, {0,0,1,1,1,0,0,1}, 
{1,0,1,0,2,0,0,0}, {0,1,1,0,2,0,0,0}, {0,0,2,0,2,0,0,0}, {0,0,1,1,2,0,0,0}, 
{0,0,1,0,3,0,0,0}, {0,0,1,0,2,1,0,0}, {0,0,1,0,2,0,1,0}, {0,0,1,0,2,0,0,1}, 
{1,0,1,0,1,1,0,0}, {0,1,1,0,1,1,0,0}, {0,0,2,0,1,1,0,0}, {0,0,1,1,1,1,0,0}, 
{0,0,1,0,2,1,0,0}, {0,0,1,0,1,2,0,0}, {0,0,1,0,1,1,1,0}, {0,0,1,0,1,1,0,1}, 
{1,0,1,0,1,0,1,0}, {0,1,1,0,1,0,1,0}, {0,0,2,0,1,0,1,0}, {0,0,1,1,1,0,1,0}, 
{0,0,1,0,2,0,1,0}, {0,0,1,0,1,1,1,0}, {0,0,1,0,1,0,2,0}, {0,0,1,0,1,0,1,1}, 
{1,0,1,0,1,0,0,1}, {0,1,1,0,1,0,0,1}, {0,0,2,0,1,0,0,1}, {0,0,1,1,1,0,0,1}, 
{0,0,1,0,2,0,0,1}, {0,0,1,0,1,1,0,1}, {0,0,1,0,1,0,1,1}, {0,0,1,0,1,0,0,2}, 
{2,0,1,0,0,1,0,0}, {1,1,1,0,0,1,0,0}, {1,0,2,0,0,1,0,0}, {1,0,1,1,0,1,0,0}, 
{1,0,1,0,1,1,0,0}, {1,0,1,0,0,2,0,0}, {1,0,1,0,0,1,1,0}, {1,0,1,0,0,1,0,1}, 
{1,1,1,0,0,1,0,0}, {0,2,1,0,0,1,0,0}, {0,1,2,0,0,1,0,0}, {0,1,1,1,0,1,0,0}, 
{0,1,1,0,1,1,0,0}, {0,1,1,0,0,2,0,0}, {0,1,1,0,0,1,1,0}, {0,1,1,0,0,1,0,1}, 
{1,0,2,0,0,1,0,0}, {0,1,2,0,0,1,0,0}, {0,0,3,0,0,1,0,0}, {0,0,2,1,0,1,0,0}, 
{0,0,2,0,1,1,0,0}, {0,0,2,0,0,2,0,0}, {0,0,2,0,0,1,1,0}, {0,0,2,0,0,1,0,1}, 
{1,0,1,1,0,1,0,0}, {0,1,1,1,0,1,0,0}, {0,0,2,1,0,1,0,0}, {0,0,1,2,0,1,0,0}, 
{0,0,1,1,1,1,0,0}, {0,0,1,1,0,2,0,0}, {0,0,1,1,0,1,1,0}, {0,0,1,1,0,1,0,1}, 
{1,0,1,0,1,1,0,0}, {0,1,1,0,1,1,0,0}, {0,0,2,0,1,1,0,0}, {0,0,1,1,1,1,0,0}, 
{0,0,1,0,2,1,0,0}, {0,0,1,0,1,2,0,0}, {0,0,1,0,1,1,1,0}, {0,0,1,0,1,1,0,1}, 
{1,0,1,0,0,2,0,0}, {0,1,1,0,0,2,0,0}, {0,0,2,0,0,2,0,0}, {0,0,1,1,0,2,0,0}, 
{0,0,1,0,1,2,0,0}, {0,0,1,0,0,3,0,0}, {0,0,1,0,0,2,1,0}, {0,0,1,0,0,2,0,1}, 
{1,0,1,0,0,1,1,0}, {0,1,1,0,0,1,1,0}, {0,0,2,0,0,1,1,0}, {0,0,1,1,0,1,1,0}, 
{0,0,1,0,1,1,1,0}, {0,0,1,0,0,2,1,0}, {0,0,1,0,0,1,2,0}, {0,0,1,0,0,1,1,1}, 
{1,0,1,0,0,1,0,1}, {0,1,1,0,0,1,0,1}, {0,0,2,0,0,1,0,1}, {0,0,1,1,0,1,0,1}, 
{0,0,1,0,1,1,0,1}, {0,0,1,0,0,2,0,1}, {0,0,1,0,0,1,1,1}, {0,0,1,0,0,1,0,2}, 
{2,0,1,0,0,0,1,0}, {1,1,1,0,0,0,1,0}, {1,0,2,0,0,0,1,0}, {1,0,1,1,0,0,1,0}, 
{1,0,1,0,1,0,1,0}, {1,0,1,0,0,1,1,0}, {1,0,1,0,0,0,2,0}, {1,0,1,0,0,0,1,1}, 
{1,1,1,0,0,0,1,0}, {0,2,1,0,0,0,1,0}, {0,1,2,0,0,0,1,0}, {0,1,1,1,0,0,1,0}, 
{0,1,1,0,1,0,1,0}, {0,1,1,0,0,1,1,0}, {0,1,1,0,0,0,2,0}, {0,1,1,0,0,0,1,1}, 
{1,0,2,0,0,0,1,0}, {0,1,2,0,0,0,1,0}, {0,0,3,0,0,0,1,0}, {0,0,2,1,0,0,1,0}, 
{0,0,2,0,1,0,1,0}, {0,0,2,0,0,1,1,0}, {0,0,2,0,0,0,2,0}, {0,0,2,0,0,0,1,1}, 
{1,0,1,1,0,0,1,0}, {0,1,1,1,0,0,1,0}, {0,0,2,1,0,0,1,0}, {0,0,1,2,0,0,1,0}, 
{0,0,1,1,1,0,1,0}, {0,0,1,1,0,1,1,0}, {0,0,1,1,0,0,2,0}, {0,0,1,1,0,0,1,1}, 
{1,0,1,0,1,0,1,0}, {0,1,1,0,1,0,1,0}, {0,0,2,0,1,0,1,0}, {0,0,1,1,1,0,1,0}, 
{0,0,1,0,2,0,1,0}, {0,0,1,0,1,1,1,0}, {0,0,1,0,1,0,2,0}, {0,0,1,0,1,0,1,1}, 
{1,0,1,0,0,1,1,0}, {0,1,1,0,0,1,1,0}, {0,0,2,0,0,1,1,0}, {0,0,1,1,0,1,1,0}, 
{0,0,1,0,1,1,1,0}, {0,0,1,0,0,2,1,0}, {0,0,1,0,0,1,2,0}, {0,0,1,0,0,1,1,1}, 
{1,0,1,0,0,0,2,0}, {0,1,1,0,0,0,2,0}, {0,0,2,0,0,0,2,0}, {0,0,1,1,0,0,2,0}, 
{0,0,1,0,1,0,2,0}, {0,0,1,0,0,1,2,0}, {0,0,1,0,0,0,3,0}, {0,0,1,0,0,0,2,1}, 
{1,0,1,0,0,0,1,1}, {0,1,1,0,0,0,1,1}, {0,0,2,0,0,0,1,1}, {0,0,1,1,0,0,1,1}, 
{0,0,1,0,1,0,1,1}, {0,0,1,0,0,1,1,1}, {0,0,1,0,0,0,2,1}, {0,0,1,0,0,0,1,2}, 
{2,0,1,0,0,0,0,1}, {1,1,1,0,0,0,0,1}, {1,0,2,0,0,0,0,1}, {1,0,1,1,0,0,0,1}, 
{1,0,1,0,1,0,0,1}, {1,0,1,0,0,1,0,1}, {1,0,1,0,0,0,1,1}, {1,0,1,0,0,0,0,2}, 
{1,1,1,0,0,0,0,1}, {0,2,1,0,0,0,0,1}, {0,1,2,0,0,0,0,1}, {0,1,1,1,0,0,0,1}, 
{0,1,1,0,1,0,0,1}, {0,1,1,0,0,1,0,1}, {0,1,1,0,0,0,1,1}, {0,1,1,0,0,0,0,2}, 
{1,0,2,0,0,0,0,1}, {0,1,2,0,0,0,0,1}, {0,0,3,0,0,0,0,1}, {0,0,2,1,0,0,0,1}, 
{0,0,2,0,1,0,0,1}, {0,0,2,0,0,1,0,1}, {0,0,2,0,0,0,1,1}, {0,0,2,0,0,0,0,2}, 
{1,0,1,1,0,0,0,1}, {0,1,1,1,0,0,0,1}, {0,0,2,1,0,0,0,1}, {0,0,1,2,0,0,0,1}, 
{0,0,1,1,1,0,0,1}, {0,0,1,1,0,1,0,1}, {0,0,1,1,0,0,1,1}, {0,0,1,1,0,0,0,2}, 
{1,0,1,0,1,0,0,1}, {0,1,1,0,1,0,0,1}, {0,0,2,0,1,0,0,1}, {0,0,1,1,1,0,0,1}, 
{0,0,1,0,2,0,0,1}, {0,0,1,0,1,1,0,1}, {0,0,1,0,1,0,1,1}, {0,0,1,0,1,0,0,2}, 
{1,0,1,0,0,1,0,1}, {0,1,1,0,0,1,0,1}, {0,0,2,0,0,1,0,1}, {0,0,1,1,0,1,0,1}, 
{0,0,1,0,1,1,0,1}, {0,0,1,0,0,2,0,1}, {0,0,1,0,0,1,1,1}, {0,0,1,0,0,1,0,2}, 
{1,0,1,0,0,0,1,1}, {0,1,1,0,0,0,1,1}, {0,0,2,0,0,0,1,1}, {0,0,1,1,0,0,1,1}, 
{0,0,1,0,1,0,1,1}, {0,0,1,0,0,1,1,1}, {0,0,1,0,0,0,2,1}, {0,0,1,0,0,0,1,2}, 
{1,0,1,0,0,0,0,2}, {0,1,1,0,0,0,0,2}, {0,0,2,0,0,0,0,2}, {0,0,1,1,0,0,0,2}, 
{0,0,1,0,1,0,0,2}, {0,0,1,0,0,1,0,2}, {0,0,1,0,0,0,1,2}, {0,0,1,0,0,0,0,3}, 
{3,0,0,1,0,0,0,0}, {2,1,0,1,0,0,0,0}, {2,0,1,1,0,0,0,0}, {2,0,0,2,0,0,0,0}, 
{2,0,0,1,1,0,0,0}, {2,0,0,1,0,1,0,0}, {2,0,0,1,0,0,1,0}, {2,0,0,1,0,0,0,1}, 
{2,1,0,1,0,0,0,0}, {1,2,0,1,0,0,0,0}, {1,1,1,1,0,0,0,0}, {1,1,0,2,0,0,0,0}, 
{1,1,0,1,1,0,0,0}, {1,1,0,1,0,1,0,0}, {1,1,0,1,0,0,1,0}, {1,1,0,1,0,0,0,1}, 
{2,0,1,1,0,0,0,0}, {1,1,1,1,0,0,0,0}, {1,0,2,1,0,0,0,0}, {1,0,1,2,0,0,0,0}, 
{1,0,1,1,1,0,0,0}, {1,0,1,1,0,1,0,0}, {1,0,1,1,0,0,1,0}, {1,0,1,1,0,0,0,1}, 
{2,0,0,2,0,0,0,0}, {1,1,0,2,0,0,0,0}, {1,0,1,2,0,0,0,0}, {1,0,0,3,0,0,0,0}, 
{1,0,0,2,1,0,0,0}, {1,0,0,2,0,1,0,0}, {1,0,0,2,0,0,1,0}, {1,0,0,2,0,0,0,1}, 
{2,0,0,1,1,0,0,0}, {1,1,0,1,1,0,0,0}, {1,0,1,1,1,0,0,0}, {1,0,0,2,1,0,0,0}, 
{1,0,0,1,2,0,0,0}, {1,0,0,1,1,1,0,0}, {1,0,0,1,1,0,1,0}, {1,0,0,1,1,0,0,1}, 
{2,0,0,1,0,1,0,0}, {1,1,0,1,0,1,0,0}, {1,0,1,1,0,1,0,0}, {1,0,0,2,0,1,0,0}, 
{1,0,0,1,1,1,0,0}, {1,0,0,1,0,2,0,0}, {1,0,0,1,0,1,1,0}, {1,0,0,1,0,1,0,1}, 
{2,0,0,1,0,0,1,0}, {1,1,0,1,0,0,1,0}, {1,0,1,1,0,0,1,0}, {1,0,0,2,0,0,1,0}, 
{1,0,0,1,1,0,1,0}, {1,0,0,1,0,1,1,0}, {1,0,0,1,0,0,2,0}, {1,0,0,1,0,0,1,1}, 
{2,0,0,1,0,0,0,1}, {1,1,0,1,0,0,0,1}, {1,0,1,1,0,0,0,1}, {1,0,0,2,0,0,0,1}, 
{1,0,0,1,1,0,0,1}, {1,0,0,1,0,1,0,1}, {1,0,0,1,0,0,1,1}, {1,0,0,1,0,0,0,2}, 
{2,1,0,1,0,0,0,0}, {1,2,0,1,0,0,0,0}, {1,1,1,1,0,0,0,0}, {1,1,0,2,0,0,0,0}, 
{1,1,0,1,1,0,0,0}, {1,1,0,1,0,1,0,0}, {1,1,0,1,0,0,1,0}, {1,1,0,1,0,0,0,1}, 
{1,2,0,1,0,0,0,0}, {0,3,0,1,0,0,0,0}, {0,2,1,1,0,0,0,0}, {0,2,0,2,0,0,0,0}, 
{0,2,0,1,1,0,0,0}, {0,2,0,1,0,1,0,0}, {0,2,0,1,0,0,1,0}, {0,2,0,1,0,0,0,1}, 
{1,1,1,1,0,0,0,0}, {0,2,1,1,0,0,0,0}, {0,1,2,1,0,0,0,0}, {0,1,1,2,0,0,0,0}, 
{0,1,1,1,1,0,0,0}, {0,1,1,1,0,1,0,0}, {0,1,1,1,0,0,1,0}, {0,1,1,1,0,0,0,1}, 
{1,1,0,2,0,0,0,0}, {0,2,0,2,0,0,0,0}, {0,1,1,2,0,0,0,0}, {0,1,0,3,0,0,0,0}, 
{0,1,0,2,1,0,0,0}, {0,1,0,2,0,1,0,0}, {0,1,0,2,0,0,1,0}, {0,1,0,2,0,0,0,1}, 
{1,1,0,1,1,0,0,0}, {0,2,0,1,1,0,0,0}, {0,1,1,1,1,0,0,0}, {0,1,0,2,1,0,0,0}, 
{0,1,0,1,2,0,0,0}, {0,1,0,1,1,1,0,0}, {0,1,0,1,1,0,1,0}, {0,1,0,1,1,0,0,1}, 
{1,1,0,1,0,1,0,0}, {0,2,0,1,0,1,0,0}, {0,1,1,1,0,1,0,0}, {0,1,0,2,0,1,0,0}, 
{0,1,0,1,1,1,0,0}, {0,1,0,1,0,2,0,0}, {0,1,0,1,0,1,1,0}, {0,1,0,1,0,1,0,1}, 
{1,1,0,1,0,0,1,0}, {0,2,0,1,0,0,1,0}, {0,1,1,1,0,0,1,0}, {0,1,0,2,0,0,1,0}, 
{0,1,0,1,1,0,1,0}, {0,1,0,1,0,1,1,0}, {0,1,0,1,0,0,2,0}, {0,1,0,1,0,0,1,1}, 
{1,1,0,1,0,0,0,1}, {0,2,0,1,0,0,0,1}, {0,1,1,1,0,0,0,1}, {0,1,0,2,0,0,0,1}, 
{0,1,0,1,1,0,0,1}, {0,1,0,1,0,1,0,1}, {0,1,0,1,0,0,1,1}, {0,1,0,1,0,0,0,2}, 
{2,0,1,1,0,0,0,0}, {1,1,1,1,0,0,0,0}, {1,0,2,1,0,0,0,0}, {1,0,1,2,0,0,0,0}, 
{1,0,1,1,1,0,0,0}, {1,0,1,1,0,1,0,0}, {1,0,1,1,0,0,1,0}, {1,0,1,1,0,0,0,1}, 
{1,1,1,1,0,0,0,0}, {0,2,1,1,0,0,0,0}, {0,1,2,1,0,0,0,0}, {0,1,1,2,0,0,0,0}, 
{0,1,1,1,1,0,0,0}, {0,1,1,1,0,1,0,0}, {0,1,1,1,0,0,1,0}, {0,1,1,1,0,0,0,1}, 
{1,0,2,1,0,0,0,0}, {0,1,2,1,0,0,0,0}, {0,0,3,1,0,0,0,0}, {0,0,2,2,0,0,0,0}, 
{0,0,2,1,1,0,0,0}, {0,0,2,1,0,1,0,0}, {0,0,2,1,0,0,1,0}, {0,0,2,1,0,0,0,1}, 
{1,0,1,2,0,0,0,0}, {0,1,1,2,0,0,0,0}, {0,0,2,2,0,0,0,0}, {0,0,1,3,0,0,0,0}, 
{0,0,1,2,1,0,0,0}, {0,0,1,2,0,1,0,0}, {0,0,1,2,0,0,1,0}, {0,0,1,2,0,0,0,1}, 
{1,0,1,1,1,0,0,0}, {0,1,1,1,1,0,0,0}, {0,0,2,1,1,0,0,0}, {0,0,1,2,1,0,0,0}, 
{0,0,1,1,2,0,0,0}, {0,0,1,1,1,1,0,0}, {0,0,1,1,1,0,1,0}, {0,0,1,1,1,0,0,1}, 
{1,0,1,1,0,1,0,0}, {0,1,1,1,0,1,0,0}, {0,0,2,1,0,1,0,0}, {0,0,1,2,0,1,0,0}, 
{0,0,1,1,1,1,0,0}, {0,0,1,1,0,2,0,0}, {0,0,1,1,0,1,1,0}, {0,0,1,1,0,1,0,1}, 
{1,0,1,1,0,0,1,0}, {0,1,1,1,0,0,1,0}, {0,0,2,1,0,0,1,0}, {0,0,1,2,0,0,1,0}, 
{0,0,1,1,1,0,1,0}, {0,0,1,1,0,1,1,0}, {0,0,1,1,0,0,2,0}, {0,0,1,1,0,0,1,1}, 
{1,0,1,1,0,0,0,1}, {0,1,1,1,0,0,0,1}, {0,0,2,1,0,0,0,1}, {0,0,1,2,0,0,0,1}, 
{0,0,1,1,1,0,0,1}, {0,0,1,1,0,1,0,1}, {0,0,1,1,0,0,1,1}, {0,0,1,1,0,0,0,2}, 
{2,0,0,2,0,0,0,0}, {1,1,0,2,0,0,0,0}, {1,0,1,2,0,0,0,0}, {1,0,0,3,0,0,0,0}, 
{1,0,0,2,1,0,0,0}, {1,0,0,2,0,1,0,0}, {1,0,0,2,0,0,1,0}, {1,0,0,2,0,0,0,1}, 
{1,1,0,2,0,0,0,0}, {0,2,0,2,0,0,0,0}, {0,1,1,2,0,0,0,0}, {0,1,0,3,0,0,0,0}, 
{0,1,0,2,1,0,0,0}, {0,1,0,2,0,1,0,0}, {0,1,0,2,0,0,1,0}, {0,1,0,2,0,0,0,1}, 
{1,0,1,2,0,0,0,0}, {0,1,1,2,0,0,0,0}, {0,0,2,2,0,0,0,0}, {0,0,1,3,0,0,0,0}, 
{0,0,1,2,1,0,0,0}, {0,0,1,2,0,1,0,0}, {0,0,1,2,0,0,1,0}, {0,0,1,2,0,0,0,1}, 
{1,0,0,3,0,0,0,0}, {0,1,0,3,0,0,0,0}, {0,0,1,3,0,0,0,0}, {0,0,0,4,0,0,0,0}, 
{0,0,0,3,1,0,0,0}, {0,0,0,3,0,1,0,0}, {0,0,0,3,0,0,1,0}, {0,0,0,3,0,0,0,1}, 
{1,0,0,2,1,0,0,0}, {0,1,0,2,1,0,0,0}, {0,0,1,2,1,0,0,0}, {0,0,0,3,1,0,0,0}, 
{0,0,0,2,2,0,0,0}, {0,0,0,2,1,1,0,0}, {0,0,0,2,1,0,1,0}, {0,0,0,2,1,0,0,1}, 
{1,0,0,2,0,1,0,0}, {0,1,0,2,0,1,0,0}, {0,0,1,2,0,1,0,0}, {0,0,0,3,0,1,0,0}, 
{0,0,0,2,1,1,0,0}, {0,0,0,2,0,2,0,0}, {0,0,0,2,0,1,1,0}, {0,0,0,2,0,1,0,1}, 
{1,0,0,2,0,0,1,0}, {0,1,0,2,0,0,1,0}, {0,0,1,2,0,0,1,0}, {0,0,0,3,0,0,1,0}, 
{0,0,0,2,1,0,1,0}, {0,0,0,2,0,1,1,0}, {0,0,0,2,0,0,2,0}, {0,0,0,2,0,0,1,1}, 
{1,0,0,2,0,0,0,1}, {0,1,0,2,0,0,0,1}, {0,0,1,2,0,0,0,1}, {0,0,0,3,0,0,0,1}, 
{0,0,0,2,1,0,0,1}, {0,0,0,2,0,1,0,1}, {0,0,0,2,0,0,1,1}, {0,0,0,2,0,0,0,2}, 
{2,0,0,1,1,0,0,0}, {1,1,0,1,1,0,0,0}, {1,0,1,1,1,0,0,0}, {1,0,0,2,1,0,0,0}, 
{1,0,0,1,2,0,0,0}, {1,0,0,1,1,1,0,0}, {1,0,0,1,1,0,1,0}, {1,0,0,1,1,0,0,1}, 
{1,1,0,1,1,0,0,0}, {0,2,0,1,1,0,0,0}, {0,1,1,1,1,0,0,0}, {0,1,0,2,1,0,0,0}, 
{0,1,0,1,2,0,0,0}, {0,1,0,1,1,1,0,0}, {0,1,0,1,1,0,1,0}, {0,1,0,1,1,0,0,1}, 
{1,0,1,1,1,0,0,0}, {0,1,1,1,1,0,0,0}, {0,0,2,1,1,0,0,0}, {0,0,1,2,1,0,0,0}, 
{0,0,1,1,2,0,0,0}, {0,0,1,1,1,1,0,0}, {0,0,1,1,1,0,1,0}, {0,0,1,1,1,0,0,1}, 
{1,0,0,2,1,0,0,0}, {0,1,0,2,1,0,0,0}, {0,0,1,2,1,0,0,0}, {0,0,0,3,1,0,0,0}, 
{0,0,0,2,2,0,0,0}, {0,0,0,2,1,1,0,0}, {0,0,0,2,1,0,1,0}, {0,0,0,2,1,0,0,1}, 
{1,0,0,1,2,0,0,0}, {0,1,0,1,2,0,0,0}, {0,0,1,1,2,0,0,0}, {0,0,0,2,2,0,0,0}, 
{0,0,0,1,3,0,0,0}, {0,0,0,1,2,1,0,0}, {0,0,0,1,2,0,1,0}, {0,0,0,1,2,0,0,1}, 
{1,0,0,1,1,1,0,0}, {0,1,0,1,1,1,0,0}, {0,0,1,1,1,1,0,0}, {0,0,0,2,1,1,0,0}, 
{0,0,0,1,2,1,0,0}, {0,0,0,1,1,2,0,0}, {0,0,0,1,1,1,1,0}, {0,0,0,1,1,1,0,1}, 
{1,0,0,1,1,0,1,0}, {0,1,0,1,1,0,1,0}, {0,0,1,1,1,0,1,0}, {0,0,0,2,1,0,1,0}, 
{0,0,0,1,2,0,1,0}, {0,0,0,1,1,1,1,0}, {0,0,0,1,1,0,2,0}, {0,0,0,1,1,0,1,1}, 
{1,0,0,1,1,0,0,1}, {0,1,0,1,1,0,0,1}, {0,0,1,1,1,0,0,1}, {0,0,0,2,1,0,0,1}, 
{0,0,0,1,2,0,0,1}, {0,0,0,1,1,1,0,1}, {0,0,0,1,1,0,1,1}, {0,0,0,1,1,0,0,2}, 
{2,0,0,1,0,1,0,0}, {1,1,0,1,0,1,0,0}, {1,0,1,1,0,1,0,0}, {1,0,0,2,0,1,0,0}, 
{1,0,0,1,1,1,0,0}, {1,0,0,1,0,2,0,0}, {1,0,0,1,0,1,1,0}, {1,0,0,1,0,1,0,1}, 
{1,1,0,1,0,1,0,0}, {0,2,0,1,0,1,0,0}, {0,1,1,1,0,1,0,0}, {0,1,0,2,0,1,0,0}, 
{0,1,0,1,1,1,0,0}, {0,1,0,1,0,2,0,0}, {0,1,0,1,0,1,1,0}, {0,1,0,1,0,1,0,1}, 
{1,0,1,1,0,1,0,0}, {0,1,1,1,0,1,0,0}, {0,0,2,1,0,1,0,0}, {0,0,1,2,0,1,0,0}, 
{0,0,1,1,1,1,0,0}, {0,0,1,1,0,2,0,0}, {0,0,1,1,0,1,1,0}, {0,0,1,1,0,1,0,1}, 
{1,0,0,2,0,1,0,0}, {0,1,0,2,0,1,0,0}, {0,0,1,2,0,1,0,0}, {0,0,0,3,0,1,0,0}, 
{0,0,0,2,1,1,0,0}, {0,0,0,2,0,2,0,0}, {0,0,0,2,0,1,1,0}, {0,0,0,2,0,1,0,1}, 
{1,0,0,1,1,1,0,0}, {0,1,0,1,1,1,0,0}, {0,0,1,1,1,1,0,0}, {0,0,0,2,1,1,0,0}, 
{0,0,0,1,2,1,0,0}, {0,0,0,1,1,2,0,0}, {0,0,0,1,1,1,1,0}, {0,0,0,1,1,1,0,1}, 
{1,0,0,1,0,2,0,0}, {0,1,0,1,0,2,0,0}, {0,0,1,1,0,2,0,0}, {0,0,0,2,0,2,0,0}, 
{0,0,0,1,1,2,0,0}, {0,0,0,1,0,3,0,0}, {0,0,0,1,0,2,1,0}, {0,0,0,1,0,2,0,1}, 
{1,0,0,1,0,1,1,0}, {0,1,0,1,0,1,1,0}, {0,0,1,1,0,1,1,0}, {0,0,0,2,0,1,1,0}, 
{0,0,0,1,1,1,1,0}, {0,0,0,1,0,2,1,0}, {0,0,0,1,0,1,2,0}, {0,0,0,1,0,1,1,1}, 
{1,0,0,1,0,1,0,1}, {0,1,0,1,0,1,0,1}, {0,0,1,1,0,1,0,1}, {0,0,0,2,0,1,0,1}, 
{0,0,0,1,1,1,0,1}, {0,0,0,1,0,2,0,1}, {0,0,0,1,0,1,1,1}, {0,0,0,1,0,1,0,2}, 
{2,0,0,1,0,0,1,0}, {1,1,0,1,0,0,1,0}, {1,0,1,1,0,0,1,0}, {1,0,0,2,0,0,1,0}, 
{1,0,0,1,1,0,1,0}, {1,0,0,1,0,1,1,0}, {1,0,0,1,0,0,2,0}, {1,0,0,1,0,0,1,1}, 
{1,1,0,1,0,0,1,0}, {0,2,0,1,0,0,1,0}, {0,1,1,1,0,0,1,0}, {0,1,0,2,0,0,1,0}, 
{0,1,0,1,1,0,1,0}, {0,1,0,1,0,1,1,0}, {0,1,0,1,0,0,2,0}, {0,1,0,1,0,0,1,1}, 
{1,0,1,1,0,0,1,0}, {0,1,1,1,0,0,1,0}, {0,0,2,1,0,0,1,0}, {0,0,1,2,0,0,1,0}, 
{0,0,1,1,1,0,1,0}, {0,0,1,1,0,1,1,0}, {0,0,1,1,0,0,2,0}, {0,0,1,1,0,0,1,1}, 
{1,0,0,2,0,0,1,0}, {0,1,0,2,0,0,1,0}, {0,0,1,2,0,0,1,0}, {0,0,0,3,0,0,1,0}, 
{0,0,0,2,1,0,1,0}, {0,0,0,2,0,1,1,0}, {0,0,0,2,0,0,2,0}, {0,0,0,2,0,0,1,1}, 
{1,0,0,1,1,0,1,0}, {0,1,0,1,1,0,1,0}, {0,0,1,1,1,0,1,0}, {0,0,0,2,1,0,1,0}, 
{0,0,0,1,2,0,1,0}, {0,0,0,1,1,1,1,0}, {0,0,0,1,1,0,2,0}, {0,0,0,1,1,0,1,1}, 
{1,0,0,1,0,1,1,0}, {0,1,0,1,0,1,1,0}, {0,0,1,1,0,1,1,0}, {0,0,0,2,0,1,1,0}, 
{0,0,0,1,1,1,1,0}, {0,0,0,1,0,2,1,0}, {0,0,0,1,0,1,2,0}, {0,0,0,1,0,1,1,1}, 
{1,0,0,1,0,0,2,0}, {0,1,0,1,0,0,2,0}, {0,0,1,1,0,0,2,0}, {0,0,0,2,0,0,2,0}, 
{0,0,0,1,1,0,2,0}, {0,0,0,1,0,1,2,0}, {0,0,0,1,0,0,3,0}, {0,0,0,1,0,0,2,1}, 
{1,0,0,1,0,0,1,1}, {0,1,0,1,0,0,1,1}, {0,0,1,1,0,0,1,1}, {0,0,0,2,0,0,1,1}, 
{0,0,0,1,1,0,1,1}, {0,0,0,1,0,1,1,1}, {0,0,0,1,0,0,2,1}, {0,0,0,1,0,0,1,2}, 
{2,0,0,1,0,0,0,1}, {1,1,0,1,0,0,0,1}, {1,0,1,1,0,0,0,1}, {1,0,0,2,0,0,0,1}, 
{1,0,0,1,1,0,0,1}, {1,0,0,1,0,1,0,1}, {1,0,0,1,0,0,1,1}, {1,0,0,1,0,0,0,2}, 
{1,1,0,1,0,0,0,1}, {0,2,0,1,0,0,0,1}, {0,1,1,1,0,0,0,1}, {0,1,0,2,0,0,0,1}, 
{0,1,0,1,1,0,0,1}, {0,1,0,1,0,1,0,1}, {0,1,0,1,0,0,1,1}, {0,1,0,1,0,0,0,2}, 
{1,0,1,1,0,0,0,1}, {0,1,1,1,0,0,0,1}, {0,0,2,1,0,0,0,1}, {0,0,1,2,0,0,0,1}, 
{0,0,1,1,1,0,0,1}, {0,0,1,1,0,1,0,1}, {0,0,1,1,0,0,1,1}, {0,0,1,1,0,0,0,2}, 
{1,0,0,2,0,0,0,1}, {0,1,0,2,0,0,0,1}, {0,0,1,2,0,0,0,1}, {0,0,0,3,0,0,0,1}, 
{0,0,0,2,1,0,0,1}, {0,0,0,2,0,1,0,1}, {0,0,0,2,0,0,1,1}, {0,0,0,2,0,0,0,2}, 
{1,0,0,1,1,0,0,1}, {0,1,0,1,1,0,0,1}, {0,0,1,1,1,0,0,1}, {0,0,0,2,1,0,0,1}, 
{0,0,0,1,2,0,0,1}, {0,0,0,1,1,1,0,1}, {0,0,0,1,1,0,1,1}, {0,0,0,1,1,0,0,2}, 
{1,0,0,1,0,1,0,1}, {0,1,0,1,0,1,0,1}, {0,0,1,1,0,1,0,1}, {0,0,0,2,0,1,0,1}, 
{0,0,0,1,1,1,0,1}, {0,0,0,1,0,2,0,1}, {0,0,0,1,0,1,1,1}, {0,0,0,1,0,1,0,2}, 
{1,0,0,1,0,0,1,1}, {0,1,0,1,0,0,1,1}, {0,0,1,1,0,0,1,1}, {0,0,0,2,0,0,1,1}, 
{0,0,0,1,1,0,1,1}, {0,0,0,1,0,1,1,1}, {0,0,0,1,0,0,2,1}, {0,0,0,1,0,0,1,2}, 
{1,0,0,1,0,0,0,2}, {0,1,0,1,0,0,0,2}, {0,0,1,1,0,0,0,2}, {0,0,0,2,0,0,0,2}, 
{0,0,0,1,1,0,0,2}, {0,0,0,1,0,1,0,2}, {0,0,0,1,0,0,1,2}, {0,0,0,1,0,0,0,3}, 
{3,0,0,0,1,0,0,0}, {2,1,0,0,1,0,0,0}, {2,0,1,0,1,0,0,0}, {2,0,0,1,1,0,0,0}, 
{2,0,0,0,2,0,0,0}, {2,0,0,0,1,1,0,0}, {2,0,0,0,1,0,1,0}, {2,0,0,0,1,0,0,1}, 
{2,1,0,0,1,0,0,0}, {1,2,0,0,1,0,0,0}, {1,1,1,0,1,0,0,0}, {1,1,0,1,1,0,0,0}, 
{1,1,0,0,2,0,0,0}, {1,1,0,0,1,1,0,0}, {1,1,0,0,1,0,1,0}, {1,1,0,0,1,0,0,1}, 
{2,0,1,0,1,0,0,0}, {1,1,1,0,1,0,0,0}, {1,0,2,0,1,0,0,0}, {1,0,1,1,1,0,0,0}, 
{1,0,1,0,2,0,0,0}, {1,0,1,0,1,1,0,0}, {1,0,1,0,1,0,1,0}, {1,0,1,0,1,0,0,1}, 
{2,0,0,1,1,0,0,0}, {1,1,0,1,1,0,0,0}, {1,0,1,1,1,0,0,0}, {1,0,0,2,1,0,0,0}, 
{1,0,0,1,2,0,0,0}, {1,0,0,1,1,1,0,0}, {1,0,0,1,1,0,1,0}, {1,0,0,1,1,0,0,1}, 
{2,0,0,0,2,0,0,0}, {1,1,0,0,2,0,0,0}, {1,0,1,0,2,0,0,0}, {1,0,0,1,2,0,0,0}, 
{1,0,0,0,3,0,0,0}, {1,0,0,0,2,1,0,0}, {1,0,0,0,2,0,1,0}, {1,0,0,0,2,0,0,1}, 
{2,0,0,0,1,1,0,0}, {1,1,0,0,1,1,0,0}, {1,0,1,0,1,1,0,0}, {1,0,0,1,1,1,0,0}, 
{1,0,0,0,2,1,0,0}, {1,0,0,0,1,2,0,0}, {1,0,0,0,1,1,1,0}, {1,0,0,0,1,1,0,1}, 
{2,0,0,0,1,0,1,0}, {1,1,0,0,1,0,1,0}, {1,0,1,0,1,0,1,0}, {1,0,0,1,1,0,1,0}, 
{1,0,0,0,2,0,1,0}, {1,0,0,0,1,1,1,0}, {1,0,0,0,1,0,2,0}, {1,0,0,0,1,0,1,1}, 
{2,0,0,0,1,0,0,1}, {1,1,0,0,1,0,0,1}, {1,0,1,0,1,0,0,1}, {1,0,0,1,1,0,0,1}, 
{1,0,0,0,2,0,0,1}, {1,0,0,0,1,1,0,1}, {1,0,0,0,1,0,1,1}, {1,0,0,0,1,0,0,2}, 
{2,1,0,0,1,0,0,0}, {1,2,0,0,1,0,0,0}, {1,1,1,0,1,0,0,0}, {1,1,0,1,1,0,0,0}, 
{1,1,0,0,2,0,0,0}, {1,1,0,0,1,1,0,0}, {1,1,0,0,1,0,1,0}, {1,1,0,0,1,0,0,1}, 
{1,2,0,0,1,0,0,0}, {0,3,0,0,1,0,0,0}, {0,2,1,0,1,0,0,0}, {0,2,0,1,1,0,0,0}, 
{0,2,0,0,2,0,0,0}, {0,2,0,0,1,1,0,0}, {0,2,0,0,1,0,1,0}, {0,2,0,0,1,0,0,1}, 
{1,1,1,0,1,0,0,0}, {0,2,1,0,1,0,0,0}, {0,1,2,0,1,0,0,0}, {0,1,1,1,1,0,0,0}, 
{0,1,1,0,2,0,0,0}, {0,1,1,0,1,1,0,0}, {0,1,1,0,1,0,1,0}, {0,1,1,0,1,0,0,1}, 
{1,1,0,1,1,0,0,0}, {0,2,0,1,1,0,0,0}, {0,1,1,1,1,0,0,0}, {0,1,0,2,1,0,0,0}, 
{0,1,0,1,2,0,0,0}, {0,1,0,1,1,1,0,0}, {0,1,0,1,1,0,1,0}, {0,1,0,1,1,0,0,1}, 
{1,1,0,0,2,0,0,0}, {0,2,0,0,2,0,0,0}, {0,1,1,0,2,0,0,0}, {0,1,0,1,2,0,0,0}, 
{0,1,0,0,3,0,0,0}, {0,1,0,0,2,1,0,0}, {0,1,0,0,2,0,1,0}, {0,1,0,0,2,0,0,1}, 
{1,1,0,0,1,1,0,0}, {0,2,0,0,1,1,0,0}, {0,1,1,0,1,1,0,0}, {0,1,0,1,1,1,0,0}, 
{0,1,0,0,2,1,0,0}, {0,1,0,0,1,2,0,0}, {0,1,0,0,1,1,1,0}, {0,1,0,0,1,1,0,1}, 
{1,1,0,0,1,0,1,0}, {0,2,0,0,1,0,1,0}, {0,1,1,0,1,0,1,0}, {0,1,0,1,1,0,1,0}, 
{0,1,0,0,2,0,1,0}, {0,1,0,0,1,1,1,0}, {0,1,0,0,1,0,2,0}, {0,1,0,0,1,0,1,1}, 
{1,1,0,0,1,0,0,1}, {0,2,0,0,1,0,0,1}, {0,1,1,0,1,0,0,1}, {0,1,0,1,1,0,0,1}, 
{0,1,0,0,2,0,0,1}, {0,1,0,0,1,1,0,1}, {0,1,0,0,1,0,1,1}, {0,1,0,0,1,0,0,2}, 
{2,0,1,0,1,0,0,0}, {1,1,1,0,1,0,0,0}, {1,0,2,0,1,0,0,0}, {1,0,1,1,1,0,0,0}, 
{1,0,1,0,2,0,0,0}, {1,0,1,0,1,1,0,0}, {1,0,1,0,1,0,1,0}, {1,0,1,0,1,0,0,1}, 
{1,1,1,0,1,0,0,0}, {0,2,1,0,1,0,0,0}, {0,1,2,0,1,0,0,0}, {0,1,1,1,1,0,0,0}, 
{0,1,1,0,2,0,0,0}, {0,1,1,0,1,1,0,0}, {0,1,1,0,1,0,1,0}, {0,1,1,0,1,0,0,1}, 
{1,0,2,0,1,0,0,0}, {0,1,2,0,1,0,0,0}, {0,0,3,0,1,0,0,0}, {0,0,2,1,1,0,0,0}, 
{0,0,2,0,2,0,0,0}, {0,0,2,0,1,1,0,0}, {0,0,2,0,1,0,1,0}, {0,0,2,0,1,0,0,1}, 
{1,0,1,1,1,0,0,0}, {0,1,1,1,1,0,0,0}, {0,0,2,1,1,0,0,0}, {0,0,1,2,1,0,0,0}, 
{0,0,1,1,2,0,0,0}, {0,0,1,1,1,1,0,0}, {0,0,1,1,1,0,1,0}, {0,0,1,1,1,0,0,1}, 
{1,0,1,0,2,0,0,0}, {0,1,1,0,2,0,0,0}, {0,0,2,0,2,0,0,0}, {0,0,1,1,2,0,0,0}, 
{0,0,1,0,3,0,0,0}, {0,0,1,0,2,1,0,0}, {0,0,1,0,2,0,1,0}, {0,0,1,0,2,0,0,1}, 
{1,0,1,0,1,1,0,0}, {0,1,1,0,1,1,0,0}, {0,0,2,0,1,1,0,0}, {0,0,1,1,1,1,0,0}, 
{0,0,1,0,2,1,0,0}, {0,0,1,0,1,2,0,0}, {0,0,1,0,1,1,1,0}, {0,0,1,0,1,1,0,1}, 
{1,0,1,0,1,0,1,0}, {0,1,1,0,1,0,1,0}, {0,0,2,0,1,0,1,0}, {0,0,1,1,1,0,1,0}, 
{0,0,1,0,2,0,1,0}, {0,0,1,0,1,1,1,0}, {0,0,1,0,1,0,2,0}, {0,0,1,0,1,0,1,1}, 
{1,0,1,0,1,0,0,1}, {0,1,1,0,1,0,0,1}, {0,0,2,0,1,0,0,1}, {0,0,1,1,1,0,0,1}, 
{0,0,1,0,2,0,0,1}, {0,0,1,0,1,1,0,1}, {0,0,1,0,1,0,1,1}, {0,0,1,0,1,0,0,2}, 
{2,0,0,1,1,0,0,0}, {1,1,0,1,1,0,0,0}, {1,0,1,1,1,0,0,0}, {1,0,0,2,1,0,0,0}, 
{1,0,0,1,2,0,0,0}, {1,0,0,1,1,1,0,0}, {1,0,0,1,1,0,1,0}, {1,0,0,1,1,0,0,1}, 
{1,1,0,1,1,0,0,0}, {0,2,0,1,1,0,0,0}, {0,1,1,1,1,0,0,0}, {0,1,0,2,1,0,0,0}, 
{0,1,0,1,2,0,0,0}, {0,1,0,1,1,1,0,0}, {0,1,0,1,1,0,1,0}, {0,1,0,1,1,0,0,1}, 
{1,0,1,1,1,0,0,0}, {0,1,1,1,1,0,0,0}, {0,0,2,1,1,0,0,0}, {0,0,1,2,1,0,0,0}, 
{0,0,1,1,2,0,0,0}, {0,0,1,1,1,1,0,0}, {0,0,1,1,1,0,1,0}, {0,0,1,1,1,0,0,1}, 
{1,0,0,2,1,0,0,0}, {0,1,0,2,1,0,0,0}, {0,0,1,2,1,0,0,0}, {0,0,0,3,1,0,0,0}, 
{0,0,0,2,2,0,0,0}, {0,0,0,2,1,1,0,0}, {0,0,0,2,1,0,1,0}, {0,0,0,2,1,0,0,1}, 
{1,0,0,1,2,0,0,0}, {0,1,0,1,2,0,0,0}, {0,0,1,1,2,0,0,0}, {0,0,0,2,2,0,0,0}, 
{0,0,0,1,3,0,0,0}, {0,0,0,1,2,1,0,0}, {0,0,0,1,2,0,1,0}, {0,0,0,1,2,0,0,1}, 
{1,0,0,1,1,1,0,0}, {0,1,0,1,1,1,0,0}, {0,0,1,1,1,1,0,0}, {0,0,0,2,1,1,0,0}, 
{0,0,0,1,2,1,0,0}, {0,0,0,1,1,2,0,0}, {0,0,0,1,1,1,1,0}, {0,0,0,1,1,1,0,1}, 
{1,0,0,1,1,0,1,0}, {0,1,0,1,1,0,1,0}, {0,0,1,1,1,0,1,0}, {0,0,0,2,1,0,1,0}, 
{0,0,0,1,2,0,1,0}, {0,0,0,1,1,1,1,0}, {0,0,0,1,1,0,2,0}, {0,0,0,1,1,0,1,1}, 
{1,0,0,1,1,0,0,1}, {0,1,0,1,1,0,0,1}, {0,0,1,1,1,0,0,1}, {0,0,0,2,1,0,0,1}, 
{0,0,0,1,2,0,0,1}, {0,0,0,1,1,1,0,1}, {0,0,0,1,1,0,1,1}, {0,0,0,1,1,0,0,2}, 
{2,0,0,0,2,0,0,0}, {1,1,0,0,2,0,0,0}, {1,0,1,0,2,0,0,0}, {1,0,0,1,2,0,0,0}, 
{1,0,0,0,3,0,0,0}, {1,0,0,0,2,1,0,0}, {1,0,0,0,2,0,1,0}, {1,0,0,0,2,0,0,1}, 
{1,1,0,0,2,0,0,0}, {0,2,0,0,2,0,0,0}, {0,1,1,0,2,0,0,0}, {0,1,0,1,2,0,0,0}, 
{0,1,0,0,3,0,0,0}, {0,1,0,0,2,1,0,0}, {0,1,0,0,2,0,1,0}, {0,1,0,0,2,0,0,1}, 
{1,0,1,0,2,0,0,0}, {0,1,1,0,2,0,0,0}, {0,0,2,0,2,0,0,0}, {0,0,1,1,2,0,0,0}, 
{0,0,1,0,3,0,0,0}, {0,0,1,0,2,1,0,0}, {0,0,1,0,2,0,1,0}, {0,0,1,0,2,0,0,1}, 
{1,0,0,1,2,0,0,0}, {0,1,0,1,2,0,0,0}, {0,0,1,1,2,0,0,0}, {0,0,0,2,2,0,0,0}, 
{0,0,0,1,3,0,0,0}, {0,0,0,1,2,1,0,0}, {0,0,0,1,2,0,1,0}, {0,0,0,1,2,0,0,1}, 
{1,0,0,0,3,0,0,0}, {0,1,0,0,3,0,0,0}, {0,0,1,0,3,0,0,0}, {0,0,0,1,3,0,0,0}, 
{0,0,0,0,4,0,0,0}, {0,0,0,0,3,1,0,0}, {0,0,0,0,3,0,1,0}, {0,0,0,0,3,0,0,1}, 
{1,0,0,0,2,1,0,0}, {0,1,0,0,2,1,0,0}, {0,0,1,0,2,1,0,0}, {0,0,0,1,2,1,0,0}, 
{0,0,0,0,3,1,0,0}, {0,0,0,0,2,2,0,0}, {0,0,0,0,2,1,1,0}, {0,0,0,0,2,1,0,1}, 
{1,0,0,0,2,0,1,0}, {0,1,0,0,2,0,1,0}, {0,0,1,0,2,0,1,0}, {0,0,0,1,2,0,1,0}, 
{0,0,0,0,3,0,1,0}, {0,0,0,0,2,1,1,0}, {0,0,0,0,2,0,2,0}, {0,0,0,0,2,0,1,1}, 
{1,0,0,0,2,0,0,1}, {0,1,0,0,2,0,0,1}, {0,0,1,0,2,0,0,1}, {0,0,0,1,2,0,0,1}, 
{0,0,0,0,3,0,0,1}, {0,0,0,0,2,1,0,1}, {0,0,0,0,2,0,1,1}, {0,0,0,0,2,0,0,2}, 
{2,0,0,0,1,1,0,0}, {1,1,0,0,1,1,0,0}, {1,0,1,0,1,1,0,0}, {1,0,0,1,1,1,0,0}, 
{1,0,0,0,2,1,0,0}, {1,0,0,0,1,2,0,0}, {1,0,0,0,1,1,1,0}, {1,0,0,0,1,1,0,1}, 
{1,1,0,0,1,1,0,0}, {0,2,0,0,1,1,0,0}, {0,1,1,0,1,1,0,0}, {0,1,0,1,1,1,0,0}, 
{0,1,0,0,2,1,0,0}, {0,1,0,0,1,2,0,0}, {0,1,0,0,1,1,1,0}, {0,1,0,0,1,1,0,1}, 
{1,0,1,0,1,1,0,0}, {0,1,1,0,1,1,0,0}, {0,0,2,0,1,1,0,0}, {0,0,1,1,1,1,0,0}, 
{0,0,1,0,2,1,0,0}, {0,0,1,0,1,2,0,0}, {0,0,1,0,1,1,1,0}, {0,0,1,0,1,1,0,1}, 
{1,0,0,1,1,1,0,0}, {0,1,0,1,1,1,0,0}, {0,0,1,1,1,1,0,0}, {0,0,0,2,1,1,0,0}, 
{0,0,0,1,2,1,0,0}, {0,0,0,1,1,2,0,0}, {0,0,0,1,1,1,1,0}, {0,0,0,1,1,1,0,1}, 
{1,0,0,0,2,1,0,0}, {0,1,0,0,2,1,0,0}, {0,0,1,0,2,1,0,0}, {0,0,0,1,2,1,0,0}, 
{0,0,0,0,3,1,0,0}, {0,0,0,0,2,2,0,0}, {0,0,0,0,2,1,1,0}, {0,0,0,0,2,1,0,1}, 
{1,0,0,0,1,2,0,0}, {0,1,0,0,1,2,0,0}, {0,0,1,0,1,2,0,0}, {0,0,0,1,1,2,0,0}, 
{0,0,0,0,2,2,0,0}, {0,0,0,0,1,3,0,0}, {0,0,0,0,1,2,1,0}, {0,0,0,0,1,2,0,1}, 
{1,0,0,0,1,1,1,0}, {0,1,0,0,1,1,1,0}, {0,0,1,0,1,1,1,0}, {0,0,0,1,1,1,1,0}, 
{0,0,0,0,2,1,1,0}, {0,0,0,0,1,2,1,0}, {0,0,0,0,1,1,2,0}, {0,0,0,0,1,1,1,1}, 
{1,0,0,0,1,1,0,1}, {0,1,0,0,1,1,0,1}, {0,0,1,0,1,1,0,1}, {0,0,0,1,1,1,0,1}, 
{0,0,0,0,2,1,0,1}, {0,0,0,0,1,2,0,1}, {0,0,0,0,1,1,1,1}, {0,0,0,0,1,1,0,2}, 
{2,0,0,0,1,0,1,0}, {1,1,0,0,1,0,1,0}, {1,0,1,0,1,0,1,0}, {1,0,0,1,1,0,1,0}, 
{1,0,0,0,2,0,1,0}, {1,0,0,0,1,1,1,0}, {1,0,0,0,1,0,2,0}, {1,0,0,0,1,0,1,1}, 
{1,1,0,0,1,0,1,0}, {0,2,0,0,1,0,1,0}, {0,1,1,0,1,0,1,0}, {0,1,0,1,1,0,1,0}, 
{0,1,0,0,2,0,1,0}, {0,1,0,0,1,1,1,0}, {0,1,0,0,1,0,2,0}, {0,1,0,0,1,0,1,1}, 
{1,0,1,0,1,0,1,0}, {0,1,1,0,1,0,1,0}, {0,0,2,0,1,0,1,0}, {0,0,1,1,1,0,1,0}, 
{0,0,1,0,2,0,1,0}, {0,0,1,0,1,1,1,0}, {0,0,1,0,1,0,2,0}, {0,0,1,0,1,0,1,1}, 
{1,0,0,1,1,0,1,0}, {0,1,0,1,1,0,1,0}, {0,0,1,1,1,0,1,0}, {0,0,0,2,1,0,1,0}, 
{0,0,0,1,2,0,1,0}, {0,0,0,1,1,1,1,0}, {0,0,0,1,1,0,2,0}, {0,0,0,1,1,0,1,1}, 
{1,0,0,0,2,0,1,0}, {0,1,0,0,2,0,1,0}, {0,0,1,0,2,0,1,0}, {0,0,0,1,2,0,1,0}, 
{0,0,0,0,3,0,1,0}, {0,0,0,0,2,1,1,0}, {0,0,0,0,2,0,2,0}, {0,0,0,0,2,0,1,1}, 
{1,0,0,0,1,1,1,0}, {0,1,0,0,1,1,1,0}, {0,0,1,0,1,1,1,0}, {0,0,0,1,1,1,1,0}, 
{0,0,0,0,2,1,1,0}, {0,0,0,0,1,2,1,0}, {0,0,0,0,1,1,2,0}, {0,0,0,0,1,1,1,1}, 
{1,0,0,0,1,0,2,0}, {0,1,0,0,1,0,2,0}, {0,0,1,0,1,0,2,0}, {0,0,0,1,1,0,2,0}, 
{0,0,0,0,2,0,2,0}, {0,0,0,0,1,1,2,0}, {0,0,0,0,1,0,3,0}, {0,0,0,0,1,0,2,1}, 
{1,0,0,0,1,0,1,1}, {0,1,0,0,1,0,1,1}, {0,0,1,0,1,0,1,1}, {0,0,0,1,1,0,1,1}, 
{0,0,0,0,2,0,1,1}, {0,0,0,0,1,1,1,1}, {0,0,0,0,1,0,2,1}, {0,0,0,0,1,0,1,2}, 
{2,0,0,0,1,0,0,1}, {1,1,0,0,1,0,0,1}, {1,0,1,0,1,0,0,1}, {1,0,0,1,1,0,0,1}, 
{1,0,0,0,2,0,0,1}, {1,0,0,0,1,1,0,1}, {1,0,0,0,1,0,1,1}, {1,0,0,0,1,0,0,2}, 
{1,1,0,0,1,0,0,1}, {0,2,0,0,1,0,0,1}, {0,1,1,0,1,0,0,1}, {0,1,0,1,1,0,0,1}, 
{0,1,0,0,2,0,0,1}, {0,1,0,0,1,1,0,1}, {0,1,0,0,1,0,1,1}, {0,1,0,0,1,0,0,2}, 
{1,0,1,0,1,0,0,1}, {0,1,1,0,1,0,0,1}, {0,0,2,0,1,0,0,1}, {0,0,1,1,1,0,0,1}, 
{0,0,1,0,2,0,0,1}, {0,0,1,0,1,1,0,1}, {0,0,1,0,1,0,1,1}, {0,0,1,0,1,0,0,2}, 
{1,0,0,1,1,0,0,1}, {0,1,0,1,1,0,0,1}, {0,0,1,1,1,0,0,1}, {0,0,0,2,1,0,0,1}, 
{0,0,0,1,2,0,0,1}, {0,0,0,1,1,1,0,1}, {0,0,0,1,1,0,1,1}, {0,0,0,1,1,0,0,2}, 
{1,0,0,0,2,0,0,1}, {0,1,0,0,2,0,0,1}, {0,0,1,0,2,0,0,1}, {0,0,0,1,2,0,0,1}, 
{0,0,0,0,3,0,0,1}, {0,0,0,0,2,1,0,1}, {0,0,0,0,2,0,1,1}, {0,0,0,0,2,0,0,2}, 
{1,0,0,0,1,1,0,1}, {0,1,0,0,1,1,0,1}, {0,0,1,0,1,1,0,1}, {0,0,0,1,1,1,0,1}, 
{0,0,0,0,2,1,0,1}, {0,0,0,0,1,2,0,1}, {0,0,0,0,1,1,1,1}, {0,0,0,0,1,1,0,2}, 
{1,0,0,0,1,0,1,1}, {0,1,0,0,1,0,1,1}, {0,0,1,0,1,0,1,1}, {0,0,0,1,1,0,1,1}, 
{0,0,0,0,2,0,1,1}, {0,0,0,0,1,1,1,1}, {0,0,0,0,1,0,2,1}, {0,0,0,0,1,0,1,2}, 
{1,0,0,0,1,0,0,2}, {0,1,0,0,1,0,0,2}, {0,0,1,0,1,0,0,2}, {0,0,0,1,1,0,0,2}, 
{0,0,0,0,2,0,0,2}, {0,0,0,0,1,1,0,2}, {0,0,0,0,1,0,1,2}, {0,0,0,0,1,0,0,3}, 
{3,0,0,0,0,1,0,0}, {2,1,0,0,0,1,0,0}, {2,0,1,0,0,1,0,0}, {2,0,0,1,0,1,0,0}, 
{2,0,0,0,1,1,0,0}, {2,0,0,0,0,2,0,0}, {2,0,0,0,0,1,1,0}, {2,0,0,0,0,1,0,1}, 
{2,1,0,0,0,1,0,0}, {1,2,0,0,0,1,0,0}, {1,1,1,0,0,1,0,0}, {1,1,0,1,0,1,0,0}, 
{1,1,0,0,1,1,0,0}, {1,1,0,0,0,2,0,0}, {1,1,0,0,0,1,1,0}, {1,1,0,0,0,1,0,1}, 
{2,0,1,0,0,1,0,0}, {1,1,1,0,0,1,0,0}, {1,0,2,0,0,1,0,0}, {1,0,1,1,0,1,0,0}, 
{1,0,1,0,1,1,0,0}, {1,0,1,0,0,2,0,0}, {1,0,1,0,0,1,1,0}, {1,0,1,0,0,1,0,1}, 
{2,0,0,1,0,1,0,0}, {1,1,0,1,0,1,0,0}, {1,0,1,1,0,1,0,0}, {1,0,0,2,0,1,0,0}, 
{1,0,0,1,1,1,0,0}, {1,0,0,1,0,2,0,0}, {1,0,0,1,0,1,1,0}, {1,0,0,1,0,1,0,1}, 
{2,0,0,0,1,1,0,0}, {1,1,0,0,1,1,0,0}, {1,0,1,0,1,1,0,0}, {1,0,0,1,1,1,0,0}, 
{1,0,0,0,2,1,0,0}, {1,0,0,0,1,2,0,0}, {1,0,0,0,1,1,1,0}, {1,0,0,0,1,1,0,1}, 
{2,0,0,0,0,2,0,0}, {1,1,0,0,0,2,0,0}, {1,0,1,0,0,2,0,0}, {1,0,0,1,0,2,0,0}, 
{1,0,0,0,1,2,0,0}, {1,0,0,0,0,3,0,0}, {1,0,0,0,0,2,1,0}, {1,0,0,0,0,2,0,1}, 
{2,0,0,0,0,1,1,0}, {1,1,0,0,0,1,1,0}, {1,0,1,0,0,1,1,0}, {1,0,0,1,0,1,1,0}, 
{1,0,0,0,1,1,1,0}, {1,0,0,0,0,2,1,0}, {1,0,0,0,0,1,2,0}, {1,0,0,0,0,1,1,1}, 
{2,0,0,0,0,1,0,1}, {1,1,0,0,0,1,0,1}, {1,0,1,0,0,1,0,1}, {1,0,0,1,0,1,0,1}, 
{1,0,0,0,1,1,0,1}, {1,0,0,0,0,2,0,1}, {1,0,0,0,0,1,1,1}, {1,0,0,0,0,1,0,2}, 
{2,1,0,0,0,1,0,0}, {1,2,0,0,0,1,0,0}, {1,1,1,0,0,1,0,0}, {1,1,0,1,0,1,0,0}, 
{1,1,0,0,1,1,0,0}, {1,1,0,0,0,2,0,0}, {1,1,0,0,0,1,1,0}, {1,1,0,0,0,1,0,1}, 
{1,2,0,0,0,1,0,0}, {0,3,0,0,0,1,0,0}, {0,2,1,0,0,1,0,0}, {0,2,0,1,0,1,0,0}, 
{0,2,0,0,1,1,0,0}, {0,2,0,0,0,2,0,0}, {0,2,0,0,0,1,1,0}, {0,2,0,0,0,1,0,1}, 
{1,1,1,0,0,1,0,0}, {0,2,1,0,0,1,0,0}, {0,1,2,0,0,1,0,0}, {0,1,1,1,0,1,0,0}, 
{0,1,1,0,1,1,0,0}, {0,1,1,0,0,2,0,0}, {0,1,1,0,0,1,1,0}, {0,1,1,0,0,1,0,1}, 
{1,1,0,1,0,1,0,0}, {0,2,0,1,0,1,0,0}, {0,1,1,1,0,1,0,0}, {0,1,0,2,0,1,0,0}, 
{0,1,0,1,1,1,0,0}, {0,1,0,1,0,2,0,0}, {0,1,0,1,0,1,1,0}, {0,1,0,1,0,1,0,1}, 
{1,1,0,0,1,1,0,0}, {0,2,0,0,1,1,0,0}, {0,1,1,0,1,1,0,0}, {0,1,0,1,1,1,0,0}, 
{0,1,0,0,2,1,0,0}, {0,1,0,0,1,2,0,0}, {0,1,0,0,1,1,1,0}, {0,1,0,0,1,1,0,1}, 
{1,1,0,0,0,2,0,0}, {0,2,0,0,0,2,0,0}, {0,1,1,0,0,2,0,0}, {0,1,0,1,0,2,0,0}, 
{0,1,0,0,1,2,0,0}, {0,1,0,0,0,3,0,0}, {0,1,0,0,0,2,1,0}, {0,1,0,0,0,2,0,1}, 
{1,1,0,0,0,1,1,0}, {0,2,0,0,0,1,1,0}, {0,1,1,0,0,1,1,0}, {0,1,0,1,0,1,1,0}, 
{0,1,0,0,1,1,1,0}, {0,1,0,0,0,2,1,0}, {0,1,0,0,0,1,2,0}, {0,1,0,0,0,1,1,1}, 
{1,1,0,0,0,1,0,1}, {0,2,0,0,0,1,0,1}, {0,1,1,0,0,1,0,1}, {0,1,0,1,0,1,0,1}, 
{0,1,0,0,1,1,0,1}, {0,1,0,0,0,2,0,1}, {0,1,0,0,0,1,1,1}, {0,1,0,0,0,1,0,2}, 
{2,0,1,0,0,1,0,0}, {1,1,1,0,0,1,0,0}, {1,0,2,0,0,1,0,0}, {1,0,1,1,0,1,0,0}, 
{1,0,1,0,1,1,0,0}, {1,0,1,0,0,2,0,0}, {1,0,1,0,0,1,1,0}, {1,0,1,0,0,1,0,1}, 
{1,1,1,0,0,1,0,0}, {0,2,1,0,0,1,0,0}, {0,1,2,0,0,1,0,0}, {0,1,1,1,0,1,0,0}, 
{0,1,1,0,1,1,0,0}, {0,1,1,0,0,2,0,0}, {0,1,1,0,0,1,1,0}, {0,1,1,0,0,1,0,1}, 
{1,0,2,0,0,1,0,0}, {0,1,2,0,0,1,0,0}, {0,0,3,0,0,1,0,0}, {0,0,2,1,0,1,0,0}, 
{0,0,2,0,1,1,0,0}, {0,0,2,0,0,2,0,0}, {0,0,2,0,0,1,1,0}, {0,0,2,0,0,1,0,1}, 
{1,0,1,1,0,1,0,0}, {0,1,1,1,0,1,0,0}, {0,0,2,1,0,1,0,0}, {0,0,1,2,0,1,0,0}, 
{0,0,1,1,1,1,0,0}, {0,0,1,1,0,2,0,0}, {0,0,1,1,0,1,1,0}, {0,0,1,1,0,1,0,1}, 
{1,0,1,0,1,1,0,0}, {0,1,1,0,1,1,0,0}, {0,0,2,0,1,1,0,0}, {0,0,1,1,1,1,0,0}, 
{0,0,1,0,2,1,0,0}, {0,0,1,0,1,2,0,0}, {0,0,1,0,1,1,1,0}, {0,0,1,0,1,1,0,1}, 
{1,0,1,0,0,2,0,0}, {0,1,1,0,0,2,0,0}, {0,0,2,0,0,2,0,0}, {0,0,1,1,0,2,0,0}, 
{0,0,1,0,1,2,0,0}, {0,0,1,0,0,3,0,0}, {0,0,1,0,0,2,1,0}, {0,0,1,0,0,2,0,1}, 
{1,0,1,0,0,1,1,0}, {0,1,1,0,0,1,1,0}, {0,0,2,0,0,1,1,0}, {0,0,1,1,0,1,1,0}, 
{0,0,1,0,1,1,1,0}, {0,0,1,0,0,2,1,0}, {0,0,1,0,0,1,2,0}, {0,0,1,0,0,1,1,1}, 
{1,0,1,0,0,1,0,1}, {0,1,1,0,0,1,0,1}, {0,0,2,0,0,1,0,1}, {0,0,1,1,0,1,0,1}, 
{0,0,1,0,1,1,0,1}, {0,0,1,0,0,2,0,1}, {0,0,1,0,0,1,1,1}, {0,0,1,0,0,1,0,2}, 
{2,0,0,1,0,1,0,0}, {1,1,0,1,0,1,0,0}, {1,0,1,1,0,1,0,0}, {1,0,0,2,0,1,0,0}, 
{1,0,0,1,1,1,0,0}, {1,0,0,1,0,2,0,0}, {1,0,0,1,0,1,1,0}, {1,0,0,1,0,1,0,1}, 
{1,1,0,1,0,1,0,0}, {0,2,0,1,0,1,0,0}, {0,1,1,1,0,1,0,0}, {0,1,0,2,0,1,0,0}, 
{0,1,0,1,1,1,0,0}, {0,1,0,1,0,2,0,0}, {0,1,0,1,0,1,1,0}, {0,1,0,1,0,1,0,1}, 
{1,0,1,1,0,1,0,0}, {0,1,1,1,0,1,0,0}, {0,0,2,1,0,1,0,0}, {0,0,1,2,0,1,0,0}, 
{0,0,1,1,1,1,0,0}, {0,0,1,1,0,2,0,0}, {0,0,1,1,0,1,1,0}, {0,0,1,1,0,1,0,1}, 
{1,0,0,2,0,1,0,0}, {0,1,0,2,0,1,0,0}, {0,0,1,2,0,1,0,0}, {0,0,0,3,0,1,0,0}, 
{0,0,0,2,1,1,0,0}, {0,0,0,2,0,2,0,0}, {0,0,0,2,0,1,1,0}, {0,0,0,2,0,1,0,1}, 
{1,0,0,1,1,1,0,0}, {0,1,0,1,1,1,0,0}, {0,0,1,1,1,1,0,0}, {0,0,0,2,1,1,0,0}, 
{0,0,0,1,2,1,0,0}, {0,0,0,1,1,2,0,0}, {0,0,0,1,1,1,1,0}, {0,0,0,1,1,1,0,1}, 
{1,0,0,1,0,2,0,0}, {0,1,0,1,0,2,0,0}, {0,0,1,1,0,2,0,0}, {0,0,0,2,0,2,0,0}, 
{0,0,0,1,1,2,0,0}, {0,0,0,1,0,3,0,0}, {0,0,0,1,0,2,1,0}, {0,0,0,1,0,2,0,1}, 
{1,0,0,1,0,1,1,0}, {0,1,0,1,0,1,1,0}, {0,0,1,1,0,1,1,0}, {0,0,0,2,0,1,1,0}, 
{0,0,0,1,1,1,1,0}, {0,0,0,1,0,2,1,0}, {0,0,0,1,0,1,2,0}, {0,0,0,1,0,1,1,1}, 
{1,0,0,1,0,1,0,1}, {0,1,0,1,0,1,0,1}, {0,0,1,1,0,1,0,1}, {0,0,0,2,0,1,0,1}, 
{0,0,0,1,1,1,0,1}, {0,0,0,1,0,2,0,1}, {0,0,0,1,0,1,1,1}, {0,0,0,1,0,1,0,2}, 
{2,0,0,0,1,1,0,0}, {1,1,0,0,1,1,0,0}, {1,0,1,0,1,1,0,0}, {1,0,0,1,1,1,0,0}, 
{1,0,0,0,2,1,0,0}, {1,0,0,0,1,2,0,0}, {1,0,0,0,1,1,1,0}, {1,0,0,0,1,1,0,1}, 
{1,1,0,0,1,1,0,0}, {0,2,0,0,1,1,0,0}, {0,1,1,0,1,1,0,0}, {0,1,0,1,1,1,0,0}, 
{0,1,0,0,2,1,0,0}, {0,1,0,0,1,2,0,0}, {0,1,0,0,1,1,1,0}, {0,1,0,0,1,1,0,1}, 
{1,0,1,0,1,1,0,0}, {0,1,1,0,1,1,0,0}, {0,0,2,0,1,1,0,0}, {0,0,1,1,1,1,0,0}, 
{0,0,1,0,2,1,0,0}, {0,0,1,0,1,2,0,0}, {0,0,1,0,1,1,1,0}, {0,0,1,0,1,1,0,1}, 
{1,0,0,1,1,1,0,0}, {0,1,0,1,1,1,0,0}, {0,0,1,1,1,1,0,0}, {0,0,0,2,1,1,0,0}, 
{0,0,0,1,2,1,0,0}, {0,0,0,1,1,2,0,0}, {0,0,0,1,1,1,1,0}, {0,0,0,1,1,1,0,1}, 
{1,0,0,0,2,1,0,0}, {0,1,0,0,2,1,0,0}, {0,0,1,0,2,1,0,0}, {0,0,0,1,2,1,0,0}, 
{0,0,0,0,3,1,0,0}, {0,0,0,0,2,2,0,0}, {0,0,0,0,2,1,1,0}, {0,0,0,0,2,1,0,1}, 
{1,0,0,0,1,2,0,0}, {0,1,0,0,1,2,0,0}, {0,0,1,0,1,2,0,0}, {0,0,0,1,1,2,0,0}, 
{0,0,0,0,2,2,0,0}, {0,0,0,0,1,3,0,0}, {0,0,0,0,1,2,1,0}, {0,0,0,0,1,2,0,1}, 
{1,0,0,0,1,1,1,0}, {0,1,0,0,1,1,1,0}, {0,0,1,0,1,1,1,0}, {0,0,0,1,1,1,1,0}, 
{0,0,0,0,2,1,1,0}, {0,0,0,0,1,2,1,0}, {0,0,0,0,1,1,2,0}, {0,0,0,0,1,1,1,1}, 
{1,0,0,0,1,1,0,1}, {0,1,0,0,1,1,0,1}, {0,0,1,0,1,1,0,1}, {0,0,0,1,1,1,0,1}, 
{0,0,0,0,2,1,0,1}, {0,0,0,0,1,2,0,1}, {0,0,0,0,1,1,1,1}, {0,0,0,0,1,1,0,2}, 
{2,0,0,0,0,2,0,0}, {1,1,0,0,0,2,0,0}, {1,0,1,0,0,2,0,0}, {1,0,0,1,0,2,0,0}, 
{1,0,0,0,1,2,0,0}, {1,0,0,0,0,3,0,0}, {1,0,0,0,0,2,1,0}, {1,0,0,0,0,2,0,1}, 
{1,1,0,0,0,2,0,0}, {0,2,0,0,0,2,0,0}, {0,1,1,0,0,2,0,0}, {0,1,0,1,0,2,0,0}, 
{0,1,0,0,1,2,0,0}, {0,1,0,0,0,3,0,0}, {0,1,0,0,0,2,1,0}, {0,1,0,0,0,2,0,1}, 
{1,0,1,0,0,2,0,0}, {0,1,1,0,0,2,0,0}, {0,0,2,0,0,2,0,0}, {0,0,1,1,0,2,0,0}, 
{0,0,1,0,1,2,0,0}, {0,0,1,0,0,3,0,0}, {0,0,1,0,0,2,1,0}, {0,0,1,0,0,2,0,1}, 
{1,0,0,1,0,2,0,0}, {0,1,0,1,0,2,0,0}, {0,0,1,1,0,2,0,0}, {0,0,0,2,0,2,0,0}, 
{0,0,0,1,1,2,0,0}, {0,0,0,1,0,3,0,0}, {0,0,0,1,0,2,1,0}, {0,0,0,1,0,2,0,1}, 
{1,0,0,0,1,2,0,0}, {0,1,0,0,1,2,0,0}, {0,0,1,0,1,2,0,0}, {0,0,0,1,1,2,0,0}, 
{0,0,0,0,2,2,0,0}, {0,0,0,0,1,3,0,0}, {0,0,0,0,1,2,1,0}, {0,0,0,0,1,2,0,1}, 
{1,0,0,0,0,3,0,0}, {0,1,0,0,0,3,0,0}, {0,0,1,0,0,3,0,0}, {0,0,0,1,0,3,0,0}, 
{0,0,0,0,1,3,0,0}, {0,0,0,0,0,4,0,0}, {0,0,0,0,0,3,1,0}, {0,0,0,0,0,3,0,1}, 
{1,0,0,0,0,2,1,0}, {0,1,0,0,0,2,1,0}, {0,0,1,0,0,2,1,0}, {0,0,0,1,0,2,1,0}, 
{0,0,0,0,1,2,1,0}, {0,0,0,0,0,3,1,0}, {0,0,0,0,0,2,2,0}, {0,0,0,0,0,2,1,1}, 
{1,0,0,0,0,2,0,1}, {0,1,0,0,0,2,0,1}, {0,0,1,0,0,2,0,1}, {0,0,0,1,0,2,0,1}, 
{0,0,0,0,1,2,0,1}, {0,0,0,0,0,3,0,1}, {0,0,0,0,0,2,1,1}, {0,0,0,0,0,2,0,2}, 
{2,0,0,0,0,1,1,0}, {1,1,0,0,0,1,1,0}, {1,0,1,0,0,1,1,0}, {1,0,0,1,0,1,1,0}, 
{1,0,0,0,1,1,1,0}, {1,0,0,0,0,2,1,0}, {1,0,0,0,0,1,2,0}, {1,0,0,0,0,1,1,1}, 
{1,1,0,0,0,1,1,0}, {0,2,0,0,0,1,1,0}, {0,1,1,0,0,1,1,0}, {0,1,0,1,0,1,1,0}, 
{0,1,0,0,1,1,1,0}, {0,1,0,0,0,2,1,0}, {0,1,0,0,0,1,2,0}, {0,1,0,0,0,1,1,1}, 
{1,0,1,0,0,1,1,0}, {0,1,1,0,0,1,1,0}, {0,0,2,0,0,1,1,0}, {0,0,1,1,0,1,1,0}, 
{0,0,1,0,1,1,1,0}, {0,0,1,0,0,2,1,0}, {0,0,1,0,0,1,2,0}, {0,0,1,0,0,1,1,1}, 
{1,0,0,1,0,1,1,0}, {0,1,0,1,0,1,1,0}, {0,0,1,1,0,1,1,0}, {0,0,0,2,0,1,1,0}, 
{0,0,0,1,1,1,1,0}, {0,0,0,1,0,2,1,0}, {0,0,0,1,0,1,2,0}, {0,0,0,1,0,1,1,1}, 
{1,0,0,0,1,1,1,0}, {0,1,0,0,1,1,1,0}, {0,0,1,0,1,1,1,0}, {0,0,0,1,1,1,1,0}, 
{0,0,0,0,2,1,1,0}, {0,0,0,0,1,2,1,0}, {0,0,0,0,1,1,2,0}, {0,0,0,0,1,1,1,1}, 
{1,0,0,0,0,2,1,0}, {0,1,0,0,0,2,1,0}, {0,0,1,0,0,2,1,0}, {0,0,0,1,0,2,1,0}, 
{0,0,0,0,1,2,1,0}, {0,0,0,0,0,3,1,0}, {0,0,0,0,0,2,2,0}, {0,0,0,0,0,2,1,1}, 
{1,0,0,0,0,1,2,0}, {0,1,0,0,0,1,2,0}, {0,0,1,0,0,1,2,0}, {0,0,0,1,0,1,2,0}, 
{0,0,0,0,1,1,2,0}, {0,0,0,0,0,2,2,0}, {0,0,0,0,0,1,3,0}, {0,0,0,0,0,1,2,1}, 
{1,0,0,0,0,1,1,1}, {0,1,0,0,0,1,1,1}, {0,0,1,0,0,1,1,1}, {0,0,0,1,0,1,1,1}, 
{0,0,0,0,1,1,1,1}, {0,0,0,0,0,2,1,1}, {0,0,0,0,0,1,2,1}, {0,0,0,0,0,1,1,2}, 
{2,0,0,0,0,1,0,1}, {1,1,0,0,0,1,0,1}, {1,0,1,0,0,1,0,1}, {1,0,0,1,0,1,0,1}, 
{1,0,0,0,1,1,0,1}, {1,0,0,0,0,2,0,1}, {1,0,0,0,0,1,1,1}, {1,0,0,0,0,1,0,2}, 
{1,1,0,0,0,1,0,1}, {0,2,0,0,0,1,0,1}, {0,1,1,0,0,1,0,1}, {0,1,0,1,0,1,0,1}, 
{0,1,0,0,1,1,0,1}, {0,1,0,0,0,2,0,1}, {0,1,0,0,0,1,1,1}, {0,1,0,0,0,1,0,2}, 
{1,0,1,0,0,1,0,1}, {0,1,1,0,0,1,0,1}, {0,0,2,0,0,1,0,1}, {0,0,1,1,0,1,0,1}, 
{0,0,1,0,1,1,0,1}, {0,0,1,0,0,2,0,1}, {0,0,1,0,0,1,1,1}, {0,0,1,0,0,1,0,2}, 
{1,0,0,1,0,1,0,1}, {0,1,0,1,0,1,0,1}, {0,0,1,1,0,1,0,1}, {0,0,0,2,0,1,0,1}, 
{0,0,0,1,1,1,0,1}, {0,0,0,1,0,2,0,1}, {0,0,0,1,0,1,1,1}, {0,0,0,1,0,1,0,2}, 
{1,0,0,0,1,1,0,1}, {0,1,0,0,1,1,0,1}, {0,0,1,0,1,1,0,1}, {0,0,0,1,1,1,0,1}, 
{0,0,0,0,2,1,0,1}, {0,0,0,0,1,2,0,1}, {0,0,0,0,1,1,1,1}, {0,0,0,0,1,1,0,2}, 
{1,0,0,0,0,2,0,1}, {0,1,0,0,0,2,0,1}, {0,0,1,0,0,2,0,1}, {0,0,0,1,0,2,0,1}, 
{0,0,0,0,1,2,0,1}, {0,0,0,0,0,3,0,1}, {0,0,0,0,0,2,1,1}, {0,0,0,0,0,2,0,2}, 
{1,0,0,0,0,1,1,1}, {0,1,0,0,0,1,1,1}, {0,0,1,0,0,1,1,1}, {0,0,0,1,0,1,1,1}, 
{0,0,0,0,1,1,1,1}, {0,0,0,0,0,2,1,1}, {0,0,0,0,0,1,2,1}, {0,0,0,0,0,1,1,2}, 
{1,0,0,0,0,1,0,2}, {0,1,0,0,0,1,0,2}, {0,0,1,0,0,1,0,2}, {0,0,0,1,0,1,0,2}, 
{0,0,0,0,1,1,0,2}, {0,0,0,0,0,2,0,2}, {0,0,0,0,0,1,1,2}, {0,0,0,0,0,1,0,3}, 
{3,0,0,0,0,0,1,0}, {2,1,0,0,0,0,1,0}, {2,0,1,0,0,0,1,0}, {2,0,0,1,0,0,1,0}, 
{2,0,0,0,1,0,1,0}, {2,0,0,0,0,1,1,0}, {2,0,0,0,0,0,2,0}, {2,0,0,0,0,0,1,1}, 
{2,1,0,0,0,0,1,0}, {1,2,0,0,0,0,1,0}, {1,1,1,0,0,0,1,0}, {1,1,0,1,0,0,1,0}, 
{1,1,0,0,1,0,1,0}, {1,1,0,0,0,1,1,0}, {1,1,0,0,0,0,2,0}, {1,1,0,0,0,0,1,1}, 
{2,0,1,0,0,0,1,0}, {1,1,1,0,0,0,1,0}, {1,0,2,0,0,0,1,0}, {1,0,1,1,0,0,1,0}, 
{1,0,1,0,1,0,1,0}, {1,0,1,0,0,1,1,0}, {1,0,1,0,0,0,2,0}, {1,0,1,0,0,0,1,1}, 
{2,0,0,1,0,0,1,0}, {1,1,0,1,0,0,1,0}, {1,0,1,1,0,0,1,0}, {1,0,0,2,0,0,1,0}, 
{1,0,0,1,1,0,1,0}, {1,0,0,1,0,1,1,0}, {1,0,0,1,0,0,2,0}, {1,0,0,1,0,0,1,1}, 
{2,0,0,0,1,0,1,0}, {1,1,0,0,1,0,1,0}, {1,0,1,0,1,0,1,0}, {1,0,0,1,1,0,1,0}, 
{1,0,0,0,2,0,1,0}, {1,0,0,0,1,1,1,0}, {1,0,0,0,1,0,2,0}, {1,0,0,0,1,0,1,1}, 
{2,0,0,0,0,1,1,0}, {1,1,0,0,0,1,1,0}, {1,0,1,0,0,1,1,0}, {1,0,0,1,0,1,1,0}, 
{1,0,0,0,1,1,1,0}, {1,0,0,0,0,2,1,0}, {1,0,0,0,0,1,2,0}, {1,0,0,0,0,1,1,1}, 
{2,0,0,0,0,0,2,0}, {1,1,0,0,0,0,2,0}, {1,0,1,0,0,0,2,0}, {1,0,0,1,0,0,2,0}, 
{1,0,0,0,1,0,2,0}, {1,0,0,0,0,1,2,0}, {1,0,0,0,0,0,3,0}, {1,0,0,0,0,0,2,1}, 
{2,0,0,0,0,0,1,1}, {1,1,0,0,0,0,1,1}, {1,0,1,0,0,0,1,1}, {1,0,0,1,0,0,1,1}, 
{1,0,0,0,1,0,1,1}, {1,0,0,0,0,1,1,1}, {1,0,0,0,0,0,2,1}, {1,0,0,0,0,0,1,2}, 
{2,1,0,0,0,0,1,0}, {1,2,0,0,0,0,1,0}, {1,1,1,0,0,0,1,0}, {1,1,0,1,0,0,1,0}, 
{1,1,0,0,1,0,1,0}, {1,1,0,0,0,1,1,0}, {1,1,0,0,0,0,2,0}, {1,1,0,0,0,0,1,1}, 
{1,2,0,0,0,0,1,0}, {0,3,0,0,0,0,1,0}, {0,2,1,0,0,0,1,0}, {0,2,0,1,0,0,1,0}, 
{0,2,0,0,1,0,1,0}, {0,2,0,0,0,1,1,0}, {0,2,0,0,0,0,2,0}, {0,2,0,0,0,0,1,1}, 
{1,1,1,0,0,0,1,0}, {0,2,1,0,0,0,1,0}, {0,1,2,0,0,0,1,0}, {0,1,1,1,0,0,1,0}, 
{0,1,1,0,1,0,1,0}, {0,1,1,0,0,1,1,0}, {0,1,1,0,0,0,2,0}, {0,1,1,0,0,0,1,1}, 
{1,1,0,1,0,0,1,0}, {0,2,0,1,0,0,1,0}, {0,1,1,1,0,0,1,0}, {0,1,0,2,0,0,1,0}, 
{0,1,0,1,1,0,1,0}, {0,1,0,1,0,1,1,0}, {0,1,0,1,0,0,2,0}, {0,1,0,1,0,0,1,1}, 
{1,1,0,0,1,0,1,0}, {0,2,0,0,1,0,1,0}, {0,1,1,0,1,0,1,0}, {0,1,0,1,1,0,1,0}, 
{0,1,0,0,2,0,1,0}, {0,1,0,0,1,1,1,0}, {0,1,0,0,1,0,2,0}, {0,1,0,0,1,0,1,1}, 
{1,1,0,0,0,1,1,0}, {0,2,0,0,0,1,1,0}, {0,1,1,0,0,1,1,0}, {0,1,0,1,0,1,1,0}, 
{0,1,0,0,1,1,1,0}, {0,1,0,0,0,2,1,0}, {0,1,0,0,0,1,2,0}, {0,1,0,0,0,1,1,1}, 
{1,1,0,0,0,0,2,0}, {0,2,0,0,0,0,2,0}, {0,1,1,0,0,0,2,0}, {0,1,0,1,0,0,2,0}, 
{0,1,0,0,1,0,2,0}, {0,1,0,0,0,1,2,0}, {0,1,0,0,0,0,3,0}, {0,1,0,0,0,0,2,1}, 
{1,1,0,0,0,0,1,1}, {0,2,0,0,0,0,1,1}, {0,1,1,0,0,0,1,1}, {0,1,0,1,0,0,1,1}, 
{0,1,0,0,1,0,1,1}, {0,1,0,0,0,1,1,1}, {0,1,0,0,0,0,2,1}, {0,1,0,0,0,0,1,2}, 
{2,0,1,0,0,0,1,0}, {1,1,1,0,0,0,1,0}, {1,0,2,0,0,0,1,0}, {1,0,1,1,0,0,1,0}, 
{1,0,1,0,1,0,1,0}, {1,0,1,0,0,1,1,0}, {1,0,1,0,0,0,2,0}, {1,0,1,0,0,0,1,1}, 
{1,1,1,0,0,0,1,0}, {0,2,1,0,0,0,1,0}, {0,1,2,0,0,0,1,0}, {0,1,1,1,0,0,1,0}, 
{0,1,1,0,1,0,1,0}, {0,1,1,0,0,1,1,0}, {0,1,1,0,0,0,2,0}, {0,1,1,0,0,0,1,1}, 
{1,0,2,0,0,0,1,0}, {0,1,2,0,0,0,1,0}, {0,0,3,0,0,0,1,0}, {0,0,2,1,0,0,1,0}, 
{0,0,2,0,1,0,1,0}, {0,0,2,0,0,1,1,0}, {0,0,2,0,0,0,2,0}, {0,0,2,0,0,0,1,1}, 
{1,0,1,1,0,0,1,0}, {0,1,1,1,0,0,1,0}, {0,0,2,1,0,0,1,0}, {0,0,1,2,0,0,1,0}, 
{0,0,1,1,1,0,1,0}, {0,0,1,1,0,1,1,0}, {0,0,1,1,0,0,2,0}, {0,0,1,1,0,0,1,1}, 
{1,0,1,0,1,0,1,0}, {0,1,1,0,1,0,1,0}, {0,0,2,0,1,0,1,0}, {0,0,1,1,1,0,1,0}, 
{0,0,1,0,2,0,1,0}, {0,0,1,0,1,1,1,0}, {0,0,1,0,1,0,2,0}, {0,0,1,0,1,0,1,1}, 
{1,0,1,0,0,1,1,0}, {0,1,1,0,0,1,1,0}, {0,0,2,0,0,1,1,0}, {0,0,1,1,0,1,1,0}, 
{0,0,1,0,1,1,1,0}, {0,0,1,0,0,2,1,0}, {0,0,1,0,0,1,2,0}, {0,0,1,0,0,1,1,1}, 
{1,0,1,0,0,0,2,0}, {0,1,1,0,0,0,2,0}, {0,0,2,0,0,0,2,0}, {0,0,1,1,0,0,2,0}, 
{0,0,1,0,1,0,2,0}, {0,0,1,0,0,1,2,0}, {0,0,1,0,0,0,3,0}, {0,0,1,0,0,0,2,1}, 
{1,0,1,0,0,0,1,1}, {0,1,1,0,0,0,1,1}, {0,0,2,0,0,0,1,1}, {0,0,1,1,0,0,1,1}, 
{0,0,1,0,1,0,1,1}, {0,0,1,0,0,1,1,1}, {0,0,1,0,0,0,2,1}, {0,0,1,0,0,0,1,2}, 
{2,0,0,1,0,0,1,0}, {1,1,0,1,0,0,1,0}, {1,0,1,1,0,0,1,0}, {1,0,0,2,0,0,1,0}, 
{1,0,0,1,1,0,1,0}, {1,0,0,1,0,1,1,0}, {1,0,0,1,0,0,2,0}, {1,0,0,1,0,0,1,1}, 
{1,1,0,1,0,0,1,0}, {0,2,0,1,0,0,1,0}, {0,1,1,1,0,0,1,0}, {0,1,0,2,0,0,1,0}, 
{0,1,0,1,1,0,1,0}, {0,1,0,1,0,1,1,0}, {0,1,0,1,0,0,2,0}, {0,1,0,1,0,0,1,1}, 
{1,0,1,1,0,0,1,0}, {0,1,1,1,0,0,1,0}, {0,0,2,1,0,0,1,0}, {0,0,1,2,0,0,1,0}, 
{0,0,1,1,1,0,1,0}, {0,0,1,1,0,1,1,0}, {0,0,1,1,0,0,2,0}, {0,0,1,1,0,0,1,1}, 
{1,0,0,2,0,0,1,0}, {0,1,0,2,0,0,1,0}, {0,0,1,2,0,0,1,0}, {0,0,0,3,0,0,1,0}, 
{0,0,0,2,1,0,1,0}, {0,0,0,2,0,1,1,0}, {0,0,0,2,0,0,2,0}, {0,0,0,2,0,0,1,1}, 
{1,0,0,1,1,0,1,0}, {0,1,0,1,1,0,1,0}, {0,0,1,1,1,0,1,0}, {0,0,0,2,1,0,1,0}, 
{0,0,0,1,2,0,1,0}, {0,0,0,1,1,1,1,0}, {0,0,0,1,1,0,2,0}, {0,0,0,1,1,0,1,1}, 
{1,0,0,1,0,1,1,0}, {0,1,0,1,0,1,1,0}, {0,0,1,1,0,1,1,0}, {0,0,0,2,0,1,1,0}, 
{0,0,0,1,1,1,1,0}, {0,0,0,1,0,2,1,0}, {0,0,0,1,0,1,2,0}, {0,0,0,1,0,1,1,1}, 
{1,0,0,1,0,0,2,0}, {0,1,0,1,0,0,2,0}, {0,0,1,1,0,0,2,0}, {0,0,0,2,0,0,2,0}, 
{0,0,0,1,1,0,2,0}, {0,0,0,1,0,1,2,0}, {0,0,0,1,0,0,3,0}, {0,0,0,1,0,0,2,1}, 
{1,0,0,1,0,0,1,1}, {0,1,0,1,0,0,1,1}, {0,0,1,1,0,0,1,1}, {0,0,0,2,0,0,1,1}, 
{0,0,0,1,1,0,1,1}, {0,0,0,1,0,1,1,1}, {0,0,0,1,0,0,2,1}, {0,0,0,1,0,0,1,2}, 
{2,0,0,0,1,0,1,0}, {1,1,0,0,1,0,1,0}, {1,0,1,0,1,0,1,0}, {1,0,0,1,1,0,1,0}, 
{1,0,0,0,2,0,1,0}, {1,0,0,0,1,1,1,0}, {1,0,0,0,1,0,2,0}, {1,0,0,0,1,0,1,1}, 
{1,1,0,0,1,0,1,0}, {0,2,0,0,1,0,1,0}, {0,1,1,0,1,0,1,0}, {0,1,0,1,1,0,1,0}, 
{0,1,0,0,2,0,1,0}, {0,1,0,0,1,1,1,0}, {0,1,0,0,1,0,2,0}, {0,1,0,0,1,0,1,1}, 
{1,0,1,0,1,0,1,0}, {0,1,1,0,1,0,1,0}, {0,0,2,0,1,0,1,0}, {0,0,1,1,1,0,1,0}, 
{0,0,1,0,2,0,1,0}, {0,0,1,0,1,1,1,0}, {0,0,1,0,1,0,2,0}, {0,0,1,0,1,0,1,1}, 
{1,0,0,1,1,0,1,0}, {0,1,0,1,1,0,1,0}, {0,0,1,1,1,0,1,0}, {0,0,0,2,1,0,1,0}, 
{0,0,0,1,2,0,1,0}, {0,0,0,1,1,1,1,0}, {0,0,0,1,1,0,2,0}, {0,0,0,1,1,0,1,1}, 
{1,0,0,0,2,0,1,0}, {0,1,0,0,2,0,1,0}, {0,0,1,0,2,0,1,0}, {0,0,0,1,2,0,1,0}, 
{0,0,0,0,3,0,1,0}, {0,0,0,0,2,1,1,0}, {0,0,0,0,2,0,2,0}, {0,0,0,0,2,0,1,1}, 
{1,0,0,0,1,1,1,0}, {0,1,0,0,1,1,1,0}, {0,0,1,0,1,1,1,0}, {0,0,0,1,1,1,1,0}, 
{0,0,0,0,2,1,1,0}, {0,0,0,0,1,2,1,0}, {0,0,0,0,1,1,2,0}, {0,0,0,0,1,1,1,1}, 
{1,0,0,0,1,0,2,0}, {0,1,0,0,1,0,2,0}, {0,0,1,0,1,0,2,0}, {0,0,0,1,1,0,2,0}, 
{0,0,0,0,2,0,2,0}, {0,0,0,0,1,1,2,0}, {0,0,0,0,1,0,3,0}, {0,0,0,0,1,0,2,1}, 
{1,0,0,0,1,0,1,1}, {0,1,0,0,1,0,1,1}, {0,0,1,0,1,0,1,1}, {0,0,0,1,1,0,1,1}, 
{0,0,0,0,2,0,1,1}, {0,0,0,0,1,1,1,1}, {0,0,0,0,1,0,2,1}, {0,0,0,0,1,0,1,2}, 
{2,0,0,0,0,1,1,0}, {1,1,0,0,0,1,1,0}, {1,0,1,0,0,1,1,0}, {1,0,0,1,0,1,1,0}, 
{1,0,0,0,1,1,1,0}, {1,0,0,0,0,2,1,0}, {1,0,0,0,0,1,2,0}, {1,0,0,0,0,1,1,1}, 
{1,1,0,0,0,1,1,0}, {0,2,0,0,0,1,1,0}, {0,1,1,0,0,1,1,0}, {0,1,0,1,0,1,1,0}, 
{0,1,0,0,1,1,1,0}, {0,1,0,0,0,2,1,0}, {0,1,0,0,0,1,2,0}, {0,1,0,0,0,1,1,1}, 
{1,0,1,0,0,1,1,0}, {0,1,1,0,0,1,1,0}, {0,0,2,0,0,1,1,0}, {0,0,1,1,0,1,1,0}, 
{0,0,1,0,1,1,1,0}, {0,0,1,0,0,2,1,0}, {0,0,1,0,0,1,2,0}, {0,0,1,0,0,1,1,1}, 
{1,0,0,1,0,1,1,0}, {0,1,0,1,0,1,1,0}, {0,0,1,1,0,1,1,0}, {0,0,0,2,0,1,1,0}, 
{0,0,0,1,1,1,1,0}, {0,0,0,1,0,2,1,0}, {0,0,0,1,0,1,2,0}, {0,0,0,1,0,1,1,1}, 
{1,0,0,0,1,1,1,0}, {0,1,0,0,1,1,1,0}, {0,0,1,0,1,1,1,0}, {0,0,0,1,1,1,1,0}, 
{0,0,0,0,2,1,1,0}, {0,0,0,0,1,2,1,0}, {0,0,0,0,1,1,2,0}, {0,0,0,0,1,1,1,1}, 
{1,0,0,0,0,2,1,0}, {0,1,0,0,0,2,1,0}, {0,0,1,0,0,2,1,0}, {0,0,0,1,0,2,1,0}, 
{0,0,0,0,1,2,1,0}, {0,0,0,0,0,3,1,0}, {0,0,0,0,0,2,2,0}, {0,0,0,0,0,2,1,1}, 
{1,0,0,0,0,1,2,0}, {0,1,0,0,0,1,2,0}, {0,0,1,0,0,1,2,0}, {0,0,0,1,0,1,2,0}, 
{0,0,0,0,1,1,2,0}, {0,0,0,0,0,2,2,0}, {0,0,0,0,0,1,3,0}, {0,0,0,0,0,1,2,1}, 
{1,0,0,0,0,1,1,1}, {0,1,0,0,0,1,1,1}, {0,0,1,0,0,1,1,1}, {0,0,0,1,0,1,1,1}, 
{0,0,0,0,1,1,1,1}, {0,0,0,0,0,2,1,1}, {0,0,0,0,0,1,2,1}, {0,0,0,0,0,1,1,2}, 
{2,0,0,0,0,0,2,0}, {1,1,0,0,0,0,2,0}, {1,0,1,0,0,0,2,0}, {1,0,0,1,0,0,2,0}, 
{1,0,0,0,1,0,2,0}, {1,0,0,0,0,1,2,0}, {1,0,0,0,0,0,3,0}, {1,0,0,0,0,0,2,1}, 
{1,1,0,0,0,0,2,0}, {0,2,0,0,0,0,2,0}, {0,1,1,0,0,0,2,0}, {0,1,0,1,0,0,2,0}, 
{0,1,0,0,1,0,2,0}, {0,1,0,0,0,1,2,0}, {0,1,0,0,0,0,3,0}, {0,1,0,0,0,0,2,1}, 
{1,0,1,0,0,0,2,0}, {0,1,1,0,0,0,2,0}, {0,0,2,0,0,0,2,0}, {0,0,1,1,0,0,2,0}, 
{0,0,1,0,1,0,2,0}, {0,0,1,0,0,1,2,0}, {0,0,1,0,0,0,3,0}, {0,0,1,0,0,0,2,1}, 
{1,0,0,1,0,0,2,0}, {0,1,0,1,0,0,2,0}, {0,0,1,1,0,0,2,0}, {0,0,0,2,0,0,2,0}, 
{0,0,0,1,1,0,2,0}, {0,0,0,1,0,1,2,0}, {0,0,0,1,0,0,3,0}, {0,0,0,1,0,0,2,1}, 
{1,0,0,0,1,0,2,0}, {0,1,0,0,1,0,2,0}, {0,0,1,0,1,0,2,0}, {0,0,0,1,1,0,2,0}, 
{0,0,0,0,2,0,2,0}, {0,0,0,0,1,1,2,0}, {0,0,0,0,1,0,3,0}, {0,0,0,0,1,0,2,1}, 
{1,0,0,0,0,1,2,0}, {0,1,0,0,0,1,2,0}, {0,0,1,0,0,1,2,0}, {0,0,0,1,0,1,2,0}, 
{0,0,0,0,1,1,2,0}, {0,0,0,0,0,2,2,0}, {0,0,0,0,0,1,3,0}, {0,0,0,0,0,1,2,1}, 
{1,0,0,0,0,0,3,0}, {0,1,0,0,0,0,3,0}, {0,0,1,0,0,0,3,0}, {0,0,0,1,0,0,3,0}, 
{0,0,0,0,1,0,3,0}, {0,0,0,0,0,1,3,0}, {0,0,0,0,0,0,4,0}, {0,0,0,0,0,0,3,1}, 
{1,0,0,0,0,0,2,1}, {0,1,0,0,0,0,2,1}, {0,0,1,0,0,0,2,1}, {0,0,0,1,0,0,2,1}, 
{0,0,0,0,1,0,2,1}, {0,0,0,0,0,1,2,1}, {0,0,0,0,0,0,3,1}, {0,0,0,0,0,0,2,2}, 
{2,0,0,0,0,0,1,1}, {1,1,0,0,0,0,1,1}, {1,0,1,0,0,0,1,1}, {1,0,0,1,0,0,1,1}, 
{1,0,0,0,1,0,1,1}, {1,0,0,0,0,1,1,1}, {1,0,0,0,0,0,2,1}, {1,0,0,0,0,0,1,2}, 
{1,1,0,0,0,0,1,1}, {0,2,0,0,0,0,1,1}, {0,1,1,0,0,0,1,1}, {0,1,0,1,0,0,1,1}, 
{0,1,0,0,1,0,1,1}, {0,1,0,0,0,1,1,1}, {0,1,0,0,0,0,2,1}, {0,1,0,0,0,0,1,2}, 
{1,0,1,0,0,0,1,1}, {0,1,1,0,0,0,1,1}, {0,0,2,0,0,0,1,1}, {0,0,1,1,0,0,1,1}, 
{0,0,1,0,1,0,1,1}, {0,0,1,0,0,1,1,1}, {0,0,1,0,0,0,2,1}, {0,0,1,0,0,0,1,2}, 
{1,0,0,1,0,0,1,1}, {0,1,0,1,0,0,1,1}, {0,0,1,1,0,0,1,1}, {0,0,0,2,0,0,1,1}, 
{0,0,0,1,1,0,1,1}, {0,0,0,1,0,1,1,1}, {0,0,0,1,0,0,2,1}, {0,0,0,1,0,0,1,2}, 
{1,0,0,0,1,0,1,1}, {0,1,0,0,1,0,1,1}, {0,0,1,0,1,0,1,1}, {0,0,0,1,1,0,1,1}, 
{0,0,0,0,2,0,1,1}, {0,0,0,0,1,1,1,1}, {0,0,0,0,1,0,2,1}, {0,0,0,0,1,0,1,2}, 
{1,0,0,0,0,1,1,1}, {0,1,0,0,0,1,1,1}, {0,0,1,0,0,1,1,1}, {0,0,0,1,0,1,1,1}, 
{0,0,0,0,1,1,1,1}, {0,0,0,0,0,2,1,1}, {0,0,0,0,0,1,2,1}, {0,0,0,0,0,1,1,2}, 
{1,0,0,0,0,0,2,1}, {0,1,0,0,0,0,2,1}, {0,0,1,0,0,0,2,1}, {0,0,0,1,0,0,2,1}, 
{0,0,0,0,1,0,2,1}, {0,0,0,0,0,1,2,1}, {0,0,0,0,0,0,3,1}, {0,0,0,0,0,0,2,2}, 
{1,0,0,0,0,0,1,2}, {0,1,0,0,0,0,1,2}, {0,0,1,0,0,0,1,2}, {0,0,0,1,0,0,1,2}, 
{0,0,0,0,1,0,1,2}, {0,0,0,0,0,1,1,2}, {0,0,0,0,0,0,2,2}, {0,0,0,0,0,0,1,3}, 
{3,0,0,0,0,0,0,1}, {2,1,0,0,0,0,0,1}, {2,0,1,0,0,0,0,1}, {2,0,0,1,0,0,0,1}, 
{2,0,0,0,1,0,0,1}, {2,0,0,0,0,1,0,1}, {2,0,0,0,0,0,1,1}, {2,0,0,0,0,0,0,2}, 
{2,1,0,0,0,0,0,1}, {1,2,0,0,0,0,0,1}, {1,1,1,0,0,0,0,1}, {1,1,0,1,0,0,0,1}, 
{1,1,0,0,1,0,0,1}, {1,1,0,0,0,1,0,1}, {1,1,0,0,0,0,1,1}, {1,1,0,0,0,0,0,2}, 
{2,0,1,0,0,0,0,1}, {1,1,1,0,0,0,0,1}, {1,0,2,0,0,0,0,1}, {1,0,1,1,0,0,0,1}, 
{1,0,1,0,1,0,0,1}, {1,0,1,0,0,1,0,1}, {1,0,1,0,0,0,1,1}, {1,0,1,0,0,0,0,2}, 
{2,0,0,1,0,0,0,1}, {1,1,0,1,0,0,0,1}, {1,0,1,1,0,0,0,1}, {1,0,0,2,0,0,0,1}, 
{1,0,0,1,1,0,0,1}, {1,0,0,1,0,1,0,1}, {1,0,0,1,0,0,1,1}, {1,0,0,1,0,0,0,2}, 
{2,0,0,0,1,0,0,1}, {1,1,0,0,1,0,0,1}, {1,0,1,0,1,0,0,1}, {1,0,0,1,1,0,0,1}, 
{1,0,0,0,2,0,0,1}, {1,0,0,0,1,1,0,1}, {1,0,0,0,1,0,1,1}, {1,0,0,0,1,0,0,2}, 
{2,0,0,0,0,1,0,1}, {1,1,0,0,0,1,0,1}, {1,0,1,0,0,1,0,1}, {1,0,0,1,0,1,0,1}, 
{1,0,0,0,1,1,0,1}, {1,0,0,0,0,2,0,1}, {1,0,0,0,0,1,1,1}, {1,0,0,0,0,1,0,2}, 
{2,0,0,0,0,0,1,1}, {1,1,0,0,0,0,1,1}, {1,0,1,0,0,0,1,1}, {1,0,0,1,0,0,1,1}, 
{1,0,0,0,1,0,1,1}, {1,0,0,0,0,1,1,1}, {1,0,0,0,0,0,2,1}, {1,0,0,0,0,0,1,2}, 
{2,0,0,0,0,0,0,2}, {1,1,0,0,0,0,0,2}, {1,0,1,0,0,0,0,2}, {1,0,0,1,0,0,0,2}, 
{1,0,0,0,1,0,0,2}, {1,0,0,0,0,1,0,2}, {1,0,0,0,0,0,1,2}, {1,0,0,0,0,0,0,3}, 
{2,1,0,0,0,0,0,1}, {1,2,0,0,0,0,0,1}, {1,1,1,0,0,0,0,1}, {1,1,0,1,0,0,0,1}, 
{1,1,0,0,1,0,0,1}, {1,1,0,0,0,1,0,1}, {1,1,0,0,0,0,1,1}, {1,1,0,0,0,0,0,2}, 
{1,2,0,0,0,0,0,1}, {0,3,0,0,0,0,0,1}, {0,2,1,0,0,0,0,1}, {0,2,0,1,0,0,0,1}, 
{0,2,0,0,1,0,0,1}, {0,2,0,0,0,1,0,1}, {0,2,0,0,0,0,1,1}, {0,2,0,0,0,0,0,2}, 
{1,1,1,0,0,0,0,1}, {0,2,1,0,0,0,0,1}, {0,1,2,0,0,0,0,1}, {0,1,1,1,0,0,0,1}, 
{0,1,1,0,1,0,0,1}, {0,1,1,0,0,1,0,1}, {0,1,1,0,0,0,1,1}, {0,1,1,0,0,0,0,2}, 
{1,1,0,1,0,0,0,1}, {0,2,0,1,0,0,0,1}, {0,1,1,1,0,0,0,1}, {0,1,0,2,0,0,0,1}, 
{0,1,0,1,1,0,0,1}, {0,1,0,1,0,1,0,1}, {0,1,0,1,0,0,1,1}, {0,1,0,1,0,0,0,2}, 
{1,1,0,0,1,0,0,1}, {0,2,0,0,1,0,0,1}, {0,1,1,0,1,0,0,1}, {0,1,0,1,1,0,0,1}, 
{0,1,0,0,2,0,0,1}, {0,1,0,0,1,1,0,1}, {0,1,0,0,1,0,1,1}, {0,1,0,0,1,0,0,2}, 
{1,1,0,0,0,1,0,1}, {0,2,0,0,0,1,0,1}, {0,1,1,0,0,1,0,1}, {0,1,0,1,0,1,0,1}, 
{0,1,0,0,1,1,0,1}, {0,1,0,0,0,2,0,1}, {0,1,0,0,0,1,1,1}, {0,1,0,0,0,1,0,2}, 
{1,1,0,0,0,0,1,1}, {0,2,0,0,0,0,1,1}, {0,1,1,0,0,0,1,1}, {0,1,0,1,0,0,1,1}, 
{0,1,0,0,1,0,1,1}, {0,1,0,0,0,1,1,1}, {0,1,0,0,0,0,2,1}, {0,1,0,0,0,0,1,2}, 
{1,1,0,0,0,0,0,2}, {0,2,0,0,0,0,0,2}, {0,1,1,0,0,0,0,2}, {0,1,0,1,0,0,0,2}, 
{0,1,0,0,1,0,0,2}, {0,1,0,0,0,1,0,2}, {0,1,0,0,0,0,1,2}, {0,1,0,0,0,0,0,3}, 
{2,0,1,0,0,0,0,1}, {1,1,1,0,0,0,0,1}, {1,0,2,0,0,0,0,1}, {1,0,1,1,0,0,0,1}, 
{1,0,1,0,1,0,0,1}, {1,0,1,0,0,1,0,1}, {1,0,1,0,0,0,1,1}, {1,0,1,0,0,0,0,2}, 
{1,1,1,0,0,0,0,1}, {0,2,1,0,0,0,0,1}, {0,1,2,0,0,0,0,1}, {0,1,1,1,0,0,0,1}, 
{0,1,1,0,1,0,0,1}, {0,1,1,0,0,1,0,1}, {0,1,1,0,0,0,1,1}, {0,1,1,0,0,0,0,2}, 
{1,0,2,0,0,0,0,1}, {0,1,2,0,0,0,0,1}, {0,0,3,0,0,0,0,1}, {0,0,2,1,0,0,0,1}, 
{0,0,2,0,1,0,0,1}, {0,0,2,0,0,1,0,1}, {0,0,2,0,0,0,1,1}, {0,0,2,0,0,0,0,2}, 
{1,0,1,1,0,0,0,1}, {0,1,1,1,0,0,0,1}, {0,0,2,1,0,0,0,1}, {0,0,1,2,0,0,0,1}, 
{0,0,1,1,1,0,0,1}, {0,0,1,1,0,1,0,1}, {0,0,1,1,0,0,1,1}, {0,0,1,1,0,0,0,2}, 
{1,0,1,0,1,0,0,1}, {0,1,1,0,1,0,0,1}, {0,0,2,0,1,0,0,1}, {0,0,1,1,1,0,0,1}, 
{0,0,1,0,2,0,0,1}, {0,0,1,0,1,1,0,1}, {0,0,1,0,1,0,1,1}, {0,0,1,0,1,0,0,2}, 
{1,0,1,0,0,1,0,1}, {0,1,1,0,0,1,0,1}, {0,0,2,0,0,1,0,1}, {0,0,1,1,0,1,0,1}, 
{0,0,1,0,1,1,0,1}, {0,0,1,0,0,2,0,1}, {0,0,1,0,0,1,1,1}, {0,0,1,0,0,1,0,2}, 
{1,0,1,0,0,0,1,1}, {0,1,1,0,0,0,1,1}, {0,0,2,0,0,0,1,1}, {0,0,1,1,0,0,1,1}, 
{0,0,1,0,1,0,1,1}, {0,0,1,0,0,1,1,1}, {0,0,1,0,0,0,2,1}, {0,0,1,0,0,0,1,2}, 
{1,0,1,0,0,0,0,2}, {0,1,1,0,0,0,0,2}, {0,0,2,0,0,0,0,2}, {0,0,1,1,0,0,0,2}, 
{0,0,1,0,1,0,0,2}, {0,0,1,0,0,1,0,2}, {0,0,1,0,0,0,1,2}, {0,0,1,0,0,0,0,3}, 
{2,0,0,1,0,0,0,1}, {1,1,0,1,0,0,0,1}, {1,0,1,1,0,0,0,1}, {1,0,0,2,0,0,0,1}, 
{1,0,0,1,1,0,0,1}, {1,0,0,1,0,1,0,1}, {1,0,0,1,0,0,1,1}, {1,0,0,1,0,0,0,2}, 
{1,1,0,1,0,0,0,1}, {0,2,0,1,0,0,0,1}, {0,1,1,1,0,0,0,1}, {0,1,0,2,0,0,0,1}, 
{0,1,0,1,1,0,0,1}, {0,1,0,1,0,1,0,1}, {0,1,0,1,0,0,1,1}, {0,1,0,1,0,0,0,2}, 
{1,0,1,1,0,0,0,1}, {0,1,1,1,0,0,0,1}, {0,0,2,1,0,0,0,1}, {0,0,1,2,0,0,0,1}, 
{0,0,1,1,1,0,0,1}, {0,0,1,1,0,1,0,1}, {0,0,1,1,0,0,1,1}, {0,0,1,1,0,0,0,2}, 
{1,0,0,2,0,0,0,1}, {0,1,0,2,0,0,0,1}, {0,0,1,2,0,0,0,1}, {0,0,0,3,0,0,0,1}, 
{0,0,0,2,1,0,0,1}, {0,0,0,2,0,1,0,1}, {0,0,0,2,0,0,1,1}, {0,0,0,2,0,0,0,2}, 
{1,0,0,1,1,0,0,1}, {0,1,0,1,1,0,0,1}, {0,0,1,1,1,0,0,1}, {0,0,0,2,1,0,0,1}, 
{0,0,0,1,2,0,0,1}, {0,0,0,1,1,1,0,1}, {0,0,0,1,1,0,1,1}, {0,0,0,1,1,0,0,2}, 
{1,0,0,1,0,1,0,1}, {0,1,0,1,0,1,0,1}, {0,0,1,1,0,1,0,1}, {0,0,0,2,0,1,0,1}, 
{0,0,0,1,1,1,0,1}, {0,0,0,1,0,2,0,1}, {0,0,0,1,0,1,1,1}, {0,0,0,1,0,1,0,2}, 
{1,0,0,1,0,0,1,1}, {0,1,0,1,0,0,1,1}, {0,0,1,1,0,0,1,1}, {0,0,0,2,0,0,1,1}, 
{0,0,0,1,1,0,1,1}, {0,0,0,1,0,1,1,1}, {0,0,0,1,0,0,2,1}, {0,0,0,1,0,0,1,2}, 
{1,0,0,1,0,0,0,2}, {0,1,0,1,0,0,0,2}, {0,0,1,1,0,0,0,2}, {0,0,0,2,0,0,0,2}, 
{0,0,0,1,1,0,0,2}, {0,0,0,1,0,1,0,2}, {0,0,0,1,0,0,1,2}, {0,0,0,1,0,0,0,3}, 
{2,0,0,0,1,0,0,1}, {1,1,0,0,1,0,0,1}, {1,0,1,0,1,0,0,1}, {1,0,0,1,1,0,0,1}, 
{1,0,0,0,2,0,0,1}, {1,0,0,0,1,1,0,1}, {1,0,0,0,1,0,1,1}, {1,0,0,0,1,0,0,2}, 
{1,1,0,0,1,0,0,1}, {0,2,0,0,1,0,0,1}, {0,1,1,0,1,0,0,1}, {0,1,0,1,1,0,0,1}, 
{0,1,0,0,2,0,0,1}, {0,1,0,0,1,1,0,1}, {0,1,0,0,1,0,1,1}, {0,1,0,0,1,0,0,2}, 
{1,0,1,0,1,0,0,1}, {0,1,1,0,1,0,0,1}, {0,0,2,0,1,0,0,1}, {0,0,1,1,1,0,0,1}, 
{0,0,1,0,2,0,0,1}, {0,0,1,0,1,1,0,1}, {0,0,1,0,1,0,1,1}, {0,0,1,0,1,0,0,2}, 
{1,0,0,1,1,0,0,1}, {0,1,0,1,1,0,0,1}, {0,0,1,1,1,0,0,1}, {0,0,0,2,1,0,0,1}, 
{0,0,0,1,2,0,0,1}, {0,0,0,1,1,1,0,1}, {0,0,0,1,1,0,1,1}, {0,0,0,1,1,0,0,2}, 
{1,0,0,0,2,0,0,1}, {0,1,0,0,2,0,0,1}, {0,0,1,0,2,0,0,1}, {0,0,0,1,2,0,0,1}, 
{0,0,0,0,3,0,0,1}, {0,0,0,0,2,1,0,1}, {0,0,0,0,2,0,1,1}, {0,0,0,0,2,0,0,2}, 
{1,0,0,0,1,1,0,1}, {0,1,0,0,1,1,0,1}, {0,0,1,0,1,1,0,1}, {0,0,0,1,1,1,0,1}, 
{0,0,0,0,2,1,0,1}, {0,0,0,0,1,2,0,1}, {0,0,0,0,1,1,1,1}, {0,0,0,0,1,1,0,2}, 
{1,0,0,0,1,0,1,1}, {0,1,0,0,1,0,1,1}, {0,0,1,0,1,0,1,1}, {0,0,0,1,1,0,1,1}, 
{0,0,0,0,2,0,1,1}, {0,0,0,0,1,1,1,1}, {0,0,0,0,1,0,2,1}, {0,0,0,0,1,0,1,2}, 
{1,0,0,0,1,0,0,2}, {0,1,0,0,1,0,0,2}, {0,0,1,0,1,0,0,2}, {0,0,0,1,1,0,0,2}, 
{0,0,0,0,2,0,0,2}, {0,0,0,0,1,1,0,2}, {0,0,0,0,1,0,1,2}, {0,0,0,0,1,0,0,3}, 
{2,0,0,0,0,1,0,1}, {1,1,0,0,0,1,0,1}, {1,0,1,0,0,1,0,1}, {1,0,0,1,0,1,0,1}, 
{1,0,0,0,1,1,0,1}, {1,0,0,0,0,2,0,1}, {1,0,0,0,0,1,1,1}, {1,0,0,0,0,1,0,2}, 
{1,1,0,0,0,1,0,1}, {0,2,0,0,0,1,0,1}, {0,1,1,0,0,1,0,1}, {0,1,0,1,0,1,0,1}, 
{0,1,0,0,1,1,0,1}, {0,1,0,0,0,2,0,1}, {0,1,0,0,0,1,1,1}, {0,1,0,0,0,1,0,2}, 
{1,0,1,0,0,1,0,1}, {0,1,1,0,0,1,0,1}, {0,0,2,0,0,1,0,1}, {0,0,1,1,0,1,0,1}, 
{0,0,1,0,1,1,0,1}, {0,0,1,0,0,2,0,1}, {0,0,1,0,0,1,1,1}, {0,0,1,0,0,1,0,2}, 
{1,0,0,1,0,1,0,1}, {0,1,0,1,0,1,0,1}, {0,0,1,1,0,1,0,1}, {0,0,0,2,0,1,0,1}, 
{0,0,0,1,1,1,0,1}, {0,0,0,1,0,2,0,1}, {0,0,0,1,0,1,1,1}, {0,0,0,1,0,1,0,2}, 
{1,0,0,0,1,1,0,1}, {0,1,0,0,1,1,0,1}, {0,0,1,0,1,1,0,1}, {0,0,0,1,1,1,0,1}, 
{0,0,0,0,2,1,0,1}, {0,0,0,0,1,2,0,1}, {0,0,0,0,1,1,1,1}, {0,0,0,0,1,1,0,2}, 
{1,0,0,0,0,2,0,1}, {0,1,0,0,0,2,0,1}, {0,0,1,0,0,2,0,1}, {0,0,0,1,0,2,0,1}, 
{0,0,0,0,1,2,0,1}, {0,0,0,0,0,3,0,1}, {0,0,0,0,0,2,1,1}, {0,0,0,0,0,2,0,2}, 
{1,0,0,0,0,1,1,1}, {0,1,0,0,0,1,1,1}, {0,0,1,0,0,1,1,1}, {0,0,0,1,0,1,1,1}, 
{0,0,0,0,1,1,1,1}, {0,0,0,0,0,2,1,1}, {0,0,0,0,0,1,2,1}, {0,0,0,0,0,1,1,2}, 
{1,0,0,0,0,1,0,2}, {0,1,0,0,0,1,0,2}, {0,0,1,0,0,1,0,2}, {0,0,0,1,0,1,0,2}, 
{0,0,0,0,1,1,0,2}, {0,0,0,0,0,2,0,2}, {0,0,0,0,0,1,1,2}, {0,0,0,0,0,1,0,3}, 
{2,0,0,0,0,0,1,1}, {1,1,0,0,0,0,1,1}, {1,0,1,0,0,0,1,1}, {1,0,0,1,0,0,1,1}, 
{1,0,0,0,1,0,1,1}, {1,0,0,0,0,1,1,1}, {1,0,0,0,0,0,2,1}, {1,0,0,0,0,0,1,2}, 
{1,1,0,0,0,0,1,1}, {0,2,0,0,0,0,1,1}, {0,1,1,0,0,0,1,1}, {0,1,0,1,0,0,1,1}, 
{0,1,0,0,1,0,1,1}, {0,1,0,0,0,1,1,1}, {0,1,0,0,0,0,2,1}, {0,1,0,0,0,0,1,2}, 
{1,0,1,0,0,0,1,1}, {0,1,1,0,0,0,1,1}, {0,0,2,0,0,0,1,1}, {0,0,1,1,0,0,1,1}, 
{0,0,1,0,1,0,1,1}, {0,0,1,0,0,1,1,1}, {0,0,1,0,0,0,2,1}, {0,0,1,0,0,0,1,2}, 
{1,0,0,1,0,0,1,1}, {0,1,0,1,0,0,1,1}, {0,0,1,1,0,0,1,1}, {0,0,0,2,0,0,1,1}, 
{0,0,0,1,1,0,1,1}, {0,0,0,1,0,1,1,1}, {0,0,0,1,0,0,2,1}, {0,0,0,1,0,0,1,2}, 
{1,0,0,0,1,0,1,1}, {0,1,0,0,1,0,1,1}, {0,0,1,0,1,0,1,1}, {0,0,0,1,1,0,1,1}, 
{0,0,0,0,2,0,1,1}, {0,0,0,0,1,1,1,1}, {0,0,0,0,1,0,2,1}, {0,0,0,0,1,0,1,2}, 
{1,0,0,0,0,1,1,1}, {0,1,0,0,0,1,1,1}, {0,0,1,0,0,1,1,1}, {0,0,0,1,0,1,1,1}, 
{0,0,0,0,1,1,1,1}, {0,0,0,0,0,2,1,1}, {0,0,0,0,0,1,2,1}, {0,0,0,0,0,1,1,2}, 
{1,0,0,0,0,0,2,1}, {0,1,0,0,0,0,2,1}, {0,0,1,0,0,0,2,1}, {0,0,0,1,0,0,2,1}, 
{0,0,0,0,1,0,2,1}, {0,0,0,0,0,1,2,1}, {0,0,0,0,0,0,3,1}, {0,0,0,0,0,0,2,2}, 
{1,0,0,0,0,0,1,2}, {0,1,0,0,0,0,1,2}, {0,0,1,0,0,0,1,2}, {0,0,0,1,0,0,1,2}, 
{0,0,0,0,1,0,1,2}, {0,0,0,0,0,1,1,2}, {0,0,0,0,0,0,2,2}, {0,0,0,0,0,0,1,3}, 
{2,0,0,0,0,0,0,2}, {1,1,0,0,0,0,0,2}, {1,0,1,0,0,0,0,2}, {1,0,0,1,0,0,0,2}, 
{1,0,0,0,1,0,0,2}, {1,0,0,0,0,1,0,2}, {1,0,0,0,0,0,1,2}, {1,0,0,0,0,0,0,3}, 
{1,1,0,0,0,0,0,2}, {0,2,0,0,0,0,0,2}, {0,1,1,0,0,0,0,2}, {0,1,0,1,0,0,0,2}, 
{0,1,0,0,1,0,0,2}, {0,1,0,0,0,1,0,2}, {0,1,0,0,0,0,1,2}, {0,1,0,0,0,0,0,3}, 
{1,0,1,0,0,0,0,2}, {0,1,1,0,0,0,0,2}, {0,0,2,0,0,0,0,2}, {0,0,1,1,0,0,0,2}, 
{0,0,1,0,1,0,0,2}, {0,0,1,0,0,1,0,2}, {0,0,1,0,0,0,1,2}, {0,0,1,0,0,0,0,3}, 
{1,0,0,1,0,0,0,2}, {0,1,0,1,0,0,0,2}, {0,0,1,1,0,0,0,2}, {0,0,0,2,0,0,0,2}, 
{0,0,0,1,1,0,0,2}, {0,0,0,1,0,1,0,2}, {0,0,0,1,0,0,1,2}, {0,0,0,1,0,0,0,3}, 
{1,0,0,0,1,0,0,2}, {0,1,0,0,1,0,0,2}, {0,0,1,0,1,0,0,2}, {0,0,0,1,1,0,0,2}, 
{0,0,0,0,2,0,0,2}, {0,0,0,0,1,1,0,2}, {0,0,0,0,1,0,1,2}, {0,0,0,0,1,0,0,3}, 
{1,0,0,0,0,1,0,2}, {0,1,0,0,0,1,0,2}, {0,0,1,0,0,1,0,2}, {0,0,0,1,0,1,0,2}, 
{0,0,0,0,1,1,0,2}, {0,0,0,0,0,2,0,2}, {0,0,0,0,0,1,1,2}, {0,0,0,0,0,1,0,3}, 
{1,0,0,0,0,0,1,2}, {0,1,0,0,0,0,1,2}, {0,0,1,0,0,0,1,2}, {0,0,0,1,0,0,1,2}, 
{0,0,0,0,1,0,1,2}, {0,0,0,0,0,1,1,2}, {0,0,0,0,0,0,2,2}, {0,0,0,0,0,0,1,3}, 
{1,0,0,0,0,0,0,3}, {0,1,0,0,0,0,0,3}, {0,0,1,0,0,0,0,3}, {0,0,0,1,0,0,0,3}, 
{0,0,0,0,1,0,0,3}, {0,0,0,0,0,1,0,3}, {0,0,0,0,0,0,1,3}, {0,0,0,0,0,0,0,4}
};

